<?php

class MicroDownloads_AlertHandler_FileUpdates extends XenForo_AlertHandler_DiscussionMessage
{

	public function getContentByIds(array $contentIds, $model, $userId, array $viewingUser)
	{

		/* @var $conversationModel XenForo_Model_Conversation */
			$Model = $model->getModelFromCache('MicroDownloads_Model_MicroDownloads');

		$files = $Model->AlertgetFileByID($contentIds);
		return $Model->unserializePermissionsInList($files, 'node_permission_cache');
	}

	protected function _prepareReply(array $item)
	{
		if ($item['extra_data'])
		{
			$item['extra'] = unserialize($item['extra_data']);
			$item['product'] = $item['extra']['product'];
		}
		unset($item['extra_data']);

		return $item;
	}

	protected function _getUpdateCondition($tableName)
	{
		return 'file_id = ' . $this->_db->quote($this->getExisting('id'));
	}
}