<?php

class MicroSupport_DataWriter_MicroSupport_Chatbg extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
            'microsupport_chat_backgrounds' => array(
                'id' => array('type' => self::TYPE_UINT, 'autoIncrement' => true),
                'title' => array('type' => self::TYPE_STRING, 'required' => false),
                'swf' => array('type' => self::TYPE_STRING, 'required' => false),
                'active' => array('type' => self::TYPE_UINT, 'required' => false),
            )
        );
    }

    protected function _getExistingData($data)
    {
		if (!$id = $this->_getExistingPrimaryKey($data, 'id'))
    {
        return false;
    }
   
    return array('microsupport_chat_backgrounds' => $this->getModelFromCache('MicroSupport_Model_MicroSupport')->_GetChatbg($id));

    }

    protected function _getUpdateCondition($tableName)
	{
		return 'id = ' . $this->_db->quote($this->getExisting('id'));
	}

	protected function _postDelete()
	{
		$deletedId = $this->_existingData['microsupport_chat_backgrounds']['id'];

    }

}
?>