<?php

class MicroSupport_DataWriter_MicroSupport_ExtraField extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
            'microsupport_fields' => array(
                'id' => array('type' => self::TYPE_UINT, 'autoIncrement' => true),
                'title' => array('type' => self::TYPE_STRING, 'required' => false),
                'description' => array('type' => self::TYPE_STRING, 'required' => false),
                'size' => array('type' => self::TYPE_UINT, 'required' => false),
                'type' => array('type' => self::TYPE_UINT, 'required' => false),
                'options' => array('type' => self::TYPE_STRING, 'required' => false),
                'displayorder' => array('type' => self::TYPE_UINT, 'required' => false),
            )
        );
    }

    protected function _getExistingData($data)
    {
		if (!$id = $this->_getExistingPrimaryKey($data, 'id'))
    {
        return false;
    }
   
    return array('microsupport_fields' => $this->getModelFromCache('MicroSupport_Model_MicroSupport')->admingetExtrafieldByID($id));

    }

    protected function _getUpdateCondition($tableName)
	{
		return 'id = ' . $this->_db->quote($this->getExisting('id'));
	}

	protected function _postDelete()
	{
		$deletedId = $this->_existingData['microsupport_fields']['id'];

    }

}
?>