<?php

class MicroSupport_DataWriter_MicroSupport_Files extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
            'microsupport_downloads' => array(
                'id' => array('type' => self::TYPE_UINT, 'autoIncrement' => true),
                'downloadtitle' => array('type' => self::TYPE_STRING, 'required' => false),
                'downloaddescription' => array('type' => self::TYPE_STRING, 'required' => false),
                'downloadfile' => array('type' => self::TYPE_STRING, 'required' => false),
                'downloadkey' => array('type' => self::TYPE_STRING, 'required' => false),
                'downloadusergroups' => array('type' => self::TYPE_BINARY, 'required' => false),
                'downloaddate' => array('type' => self::TYPE_UINT, 'required' => false),
                'downloadcount' => array('type' => self::TYPE_UINT, 'required' => false),
            )
        );
    }

    protected function _getExistingData($data)
    {
		if (!$id = $this->_getExistingPrimaryKey($data, 'id'))
    {
        return false;
    }
   
    return array('microsupport_downloads' => $this->getModelFromCache('MicroSupport_Model_MicroSupport')->getDownloadByID($id));

    }

    protected function _getUpdateCondition($tableName)
	{
		return 'id = ' . $this->_db->quote($this->getExisting('id'));
	}

	protected function _postDelete()
	{
		$deletedId = $this->_existingData['microsupport_downloads']['id'];

    }

}
?>