<?php

class MicroSupport_DataWriter_MicroSupport_License extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
            'microsupport_license_info' => array(
                'lid' => array('type' => self::TYPE_UINT, 'autoIncrement' => true),
                'microsupport_user_license' => array('type' => self::TYPE_STRING, 'required' => false),
                'microsupport_buyers_username' => array('type' => self::TYPE_STRING, 'required' => false),
            )
        );
    }

    protected function _getExistingData($data)
    {
		if (!$id = $this->_getExistingPrimaryKey($data, 'lid'))
    {
        return false;
    }
   
    return array('microsupport_license_info' => $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminLicenseinfo($id));

    }

    protected function _getUpdateCondition($tableName)
	{
		return 'lid = ' . $this->_db->quote($this->getExisting('lid'));
	}

	protected function _postDelete()
	{

		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

		$moveId = $this->getOption(self::OPTION_CAT_DESTINATION_ID);
		$deletedId = $this->_existingData['microsupport_license_info']['ld'];

    }
}
?>