<?php

class MicroSupport_DataWriter_MicroSupport_Messages extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
            'microsupport_messages' => array(
                'id' => array('type' => self::TYPE_UINT, 'autoIncrement' => true),
                'title' => array('type' => self::TYPE_STRING, 'required' => false),
                'bodytext' => array('type' => self::TYPE_STRING, 'required' => false),
            )
        );
    }

    protected function _getExistingData($data)
    {
		if (!$id = $this->_getExistingPrimaryKey($data, 'id'))
    {
        return false;
    }
   
    return array('microsupport_messages' => $this->getModelFromCache('MicroSupport_Model_MicroSupport')->getMessageByID($id));

    }

    protected function _getUpdateCondition($tableName)
	{
		return 'id = ' . $this->_db->quote($this->getExisting('id'));
	}

	protected function _postDelete()
	{
		$deletedId = $this->_existingData['microsupport_messages']['id'];

    }
}
?>