<?php

class MicroSupport_DataWriter_MicroSupport_Posttoticket extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
            'microsupport_tickets' => array(
                'id' => array('type' => self::TYPE_UINT, 'autoIncrement' => true),
                'userid' => array('type' => self::TYPE_UINT, 'required' => false),
                'departmentid' => array('type' => self::TYPE_UINT, 'required' => false),
                'productid' => array('type' => self::TYPE_UINT, 'required' => false),
                'title' => array('type' => self::TYPE_STRING, 'required' => false),
                'bodytext' => array('type' => self::TYPE_STRING, 'required' => false),
                'attachment' => array('type' => self::TYPE_STRING, 'required' => false),
                'created' => array('type' => self::TYPE_UINT, 'required' => false),
                'updated' => array('type' => self::TYPE_UINT, 'required' => false),
                'needaction' => array('type' => self::TYPE_UINT, 'required' => false),
                'priority' => array('type' => self::TYPE_UINT, 'required' => false),
                'status' => array('type' => self::TYPE_UINT, 'required' => false),
                'newreply' => array('type' => self::TYPE_UINT, 'required' => false),
                'newticket' => array('type' => self::TYPE_UINT, 'required' => false),
                'guestemail' => array('type' => self::TYPE_STRING, 'required' => false),
            )
        );
    }

    protected function _getExistingData($data)
    {
		if (!$id = $this->_getExistingPrimaryKey($data, 'id'))
    {
        return false;
    }
   
    return array('microsupport_tickets' => $this->getModelFromCache('MicroSupport_Model_MicroSupport')->GetTicket($id));

    }

    protected function _getUpdateCondition($tableName)
	{
		return 'id = ' . $this->_db->quote($this->getExisting('id'));
	}

	protected function _postDelete()
	{
		$deletedId = $this->_existingData['microsupport_tickets']['id'];

    }
}
?>