<?php

class MicroSupport_DataWriter_MicroSupport_Settings extends XenForo_DataWriter
{

    protected function _getFields()
    {
        return array(
         'microsupport_settings' => array(
         'id' => array('type' => self::TYPE_UINT, 'autoIncrement' => true),
         'onoff' => array('type' => self::TYPE_UINT, 'required' => true),
         'limit_frontpage' => array('type' => self::TYPE_UINT, 'required' => true),
         'upload_types' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_upload_path' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_departments' => array('type' => self::TYPE_UINT, 'required' => true),
         'microsupport_products' => array('type' => self::TYPE_UINT, 'required' => true),
         'microsupport_subemail_subject' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_subemail_body2' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_email_salutation' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_email_subject' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_email_body2' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_email_tech' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_live_welcometext_text' => array('type' => self::TYPE_STRING, 'required' => true),
         'microsupport_admincp_access' => array('type' => self::TYPE_STRING, 'required' => true),
         'flashjava' => array('type' => self::TYPE_UINT, 'required' => true),
         'livechatonoff' => array('type' => self::TYPE_UINT, 'required' => true),
         'microsupport_downloads' => array('type' => self::TYPE_UINT, 'required' => true),
         'news' => array('type' => self::TYPE_UINT, 'required' => true),
            )
        );
    }

    protected function _getExistingData($data)
    {
		if (!$id = $this->_getExistingPrimaryKey($data, 'id'))
    {
        return false;
    }
   
    return array('microsupport_settings' => $this->getModelFromCache('MicroSupport_Model_MicroSupport')->adminSettingsinfo($id));

    }

    protected function _getUpdateCondition($tableName)
	{
		return 'id = ' . $this->_db->quote($this->getExisting('id'));
	}

	protected function _postDelete()
	{

		$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

		$deletedId = $this->_existingData['microsupport_settings']['id'];

    }
}
?>