<?php

class MicroSupport_Model_MicroSupport extends XenForo_Model
{

    public function adminLicenseinfo($lid)
    {
		return $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_license_info
			WHERE lid = ?
		', $lid);

    }

    public function GetAddonInfo($addon = 'MicroSupport')
    {
		return $this->_getDb()->fetchRow('
			SELECT *
			FROM xf_addon
			WHERE addon_id = ?
		', $addon);

    }

    public function adminSettingsinfo($id)
    {
		return $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_settings
			WHERE id = ?
		', $id);

    }

    public function getMessageByID($id)
    {

        $cat = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_messages
            WHERE id = ?
        ', $id);

        return $cat ? $cat : false;
    }

    public function getDB()
    {
        return $this->_getDb();
    }

    public function getCountstatsopen($x,$startdate,$enddate)
    {
		$totalopen = count($this->_getDb()->fetchAll("SELECT *
FROM `microsupport_tickets`
WHERE `status` =$x
AND `created` >=$startdate
AND `created` <$enddate"));

		return $totalopen;
    }

public function getMonthLabel($mid){

    if($mid == 1)
    {
       $label = "Jan";
    }
    if($mid == 2)
    {
       $label = "Feb";
    }
    if($mid == 3)
    {
       $label = "Mar";
    }
    if($mid == 4)
    {
       $label = "Apr";
    }
    if($mid == 5)
    {
       $label = "May";
    }
    if($mid == 6)
    {
       $label = "Jun";
    }
    if($mid == 7)
    {
       $label = "Jul";
    }
    if($mid == 8)
    {
       $label = "Aug";
    }
    if($mid == 9)
    {
       $label = "Sep";
    }
    if($mid == 10)
    {
       $label = "Oct";
    }
    if($mid == 11)
    {
       $label = "Nov";
    }
    if($mid == 12)
    {
       $label = "Dec";
    }

    return $label;
}

    public function getImportants($settings)
    {
	$output = array();

	$Importants = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_faq 
			WHERE important=1 
			ORDER BY id DESC 
			LIMIT '.$settings['limit_frontpage'].'
        ');

		foreach($Importants AS $row => $Important)
		{
			$output[] = array(
                'id' => $Important['id'],
                'question' => $this->LimitTextOutput($Important['question'],$limit = 50),
                'created' => $Important['created'],
                );
		}

        return $output;
    }

    public function getLatest($settings)
    {
	$output = array();

	$Latests = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_faq  
			ORDER BY id DESC 
			LIMIT '.$settings['limit_frontpage'].'
        ');

		foreach($Latests AS $row => $Latest)
		{
			$output[] = array(
                'id' => $Latest['id'],
                'question' => $this->LimitTextOutput($Latest['question'],$limit = 50),
                'created' => $Latest['created'],
                );
		}

        return $output;
    }

    public function getFrontLatestNews($settings)
    {
	$output = array();

	$Latests = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_news 
			WHERE active = 1 
			ORDER BY id DESC
			LIMIT '.$settings['limit_frontpage'].'
        ');

		foreach($Latests AS $row => $Latest)
		{
			$output[] = array(
                'id' => $Latest['id'],
                'newstitle' => $this->LimitTextOutput($Latest['newstitle'],$limit = 50),
                'dateadded' => $Latest['dateadded'],
                );
		}

        return $output;
    }

    public function getLatestDownloads($settings)
    {
	$output = array();

	$Latests = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_downloads  
			ORDER BY id DESC
			LIMIT '.$settings['limit_frontpage'].'
        ');

		foreach($Latests AS $row => $Latest)
		{
			$output[] = array(
                'id' => $Latest['id'],
                'downloadtitle' => $this->LimitTextOutput($Latest['downloadtitle'],$limit = 50),
                'downloaddate' => $Latest['downloaddate'],
                );
		}

        return $output;
    }

    public function getResponseTime()
    {
	$output = array();

  $query = "SELECT * FROM microsupport_tickets ORDER BY id DESC LIMIT 30";
  $result = $this->_getDb()->fetchAll($query);
  $o = array();
  $i=0;
  $seconds = 0;
  
		foreach($result AS $row => $r)
		{
		$q = $this->_getDb()->fetchRow('SELECT * FROM microsupport_ticket_replies WHERE ticketid='.$r['id'].' AND created > 0');
		if ( $q == true )
         {
            $created = $r['created'];
            $updated = $q['created'];
            $seconds += $updated - $created;

            $i++;
         }
		}
  if($i>0)
  {
     $avg = $seconds / $i;
     $total_minutes = round( $avg / 60 );
     $minutes = round( $avg / 60 );
     $hours = round( ($minutes / 60));
     if ( $hours > 0 )
     {
          $h_avg = round( ($minutes / 60));
          $havg = ($minutes / 60);
          $changetomins = round(($total_minutes - ($h_avg * 60)));
          if($changetomins < 0){
             $m_avg = 0;
          }else{
             $m_avg = $changetomins;
          }
     } else {
        $h_avg = 0;
        $m_avg = $total_minutes;
     }
  } else {
     $h_avg = 0;
     $m_avg = 0;
  }
			$output[] = array(
                'm_avg' => $m_avg,
                'h_avg' => $h_avg,
                );

        return $output;
    }

    public function getextrafieldsbit()
    {
	$output = array();

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_fields 
			ORDER BY displayorder ASC, title ASC
        ');

		foreach($infos AS $row => $info)
		{
			$options = explode(",", $info['options']);
			$output[] = array(
                'id' => $info['id'],
                'title' => $info['title'],
                'description' => $info['description'],
                'type' => $info['type'],
                'size' => $info['size'],
                'options' => $options,
                'displayorder' => $info['displayorder'],
                );
		}

        return $output;
    }

    public function getdepartments()
    {

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_departments 
			ORDER BY displayorder ASC, name ASC
        ');

        return $infos;
    }

    public function getProducts()
    {

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_products 
			ORDER BY displayorder ASC, name ASC
        ');

        return $infos;
    }

	public function get_ext($key) {
	$key=strtolower(substr(strrchr($key, "."), 1));
	// Cause there the same right?
	$key=str_replace("jpeg","jpg",$key);
	return $key;
	}

	public function InsertNewTicket($input)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_tickets
                                 SET userid='.$input['userid'].',
                                     departmentid='.$input['did'].',
                                     productid='.$input['pid'].',
									 title="'.$input['title'].'",
                                     bodytext="'.$input['message'].'",
                                     attachment="'.$input['flyer_name'].'",
                                     created='.$input['created'].',
                                     updated='.$input['updated'].',
                                     needaction='.$input['needaction'].',
                                     priority='.$input['priority'].',
                                     status='.$input['status'].',
                                     newreply='.$input['newreply'].',
                                     newticket='.$input['newticket'].',
                                     guestemail="'.$input['guestemail'].'"');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function InsertNewNews($input)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_news
                                 SET newstitle="'.$input['title'].'",
                                     message="'.$input['message'].'",
                                     dateadded='.$input['created'].',
                                     active='.$input['status'].'');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function Getpriorityoption(array $viewingUser = null)

    {

        $this->standardizeViewingUserReference($viewingUser);

        return XenForo_Permission::hasPermission($viewingUser['permissions'], 'microsupport', 'microsupportprioritylevel');

    }

	public function InsertNewTicketFields($ticketid,$key,$fieldvalue)
	{

		$this->_getDb()->fetchRow("INSERT INTO microsupport_ticket_fields
                                 SET fieldid = ".$key.",
									 ticketid = ".$ticketid.",
                                     textvalue = '".$fieldvalue."'");
	}

public function getDownloadFiles($perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

  $array = array();
			$isaloud = false;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_downloads 
		GROUP BY id  
		ORDER BY downloaddate DESC 
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {

	$bbCodeParser = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));

		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));
		$output['downloaddescription'] = new XenForo_BbCode_TextWrapper($output['downloaddescription'], $bbCodeParserHtml);

				$array[] = array(
                'id' => $output['id'],
                'downloadtitle' => $output['downloadtitle'],
                'message' => $this->LimitTextOutput(strip_tags($output['downloaddescription']),$limit = 150),
                'downloadfile' => $output['downloadfile'],
                'downloadkey' => $output['downloadkey'],
                'downloadusergroups' => $output['downloadusergroups'],
                'downloaddate' => $output['downloaddate'],
                'downloadcount' => $output['downloadcount']
                );
		  

            }

  return $array;
}

    public function getCountDownloadFiles()
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_downloads`"));

		return $totalproducts;
    }

public function getMyTickets($perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		if(!$userid){
			$session = XenForo_Application::get('session');
			//print_r($session);
		$userid = preg_replace('#[^0-9]#', '', $session->get('ip'));
		//$userid = long2ip($ip);
		}

  $array = array();
			$isaloud = false;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_tickets
		WHERE userid =  '.$userid.'
		GROUP BY id  
		ORDER BY created DESC 
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {

	$bbCodeParser = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));

		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));
		$output['bodytext'] = new XenForo_BbCode_TextWrapper($output['bodytext'], $bbCodeParserHtml);

		$department = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_departments
			WHERE id = '.$output['departmentid']);

		$product = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_products
			WHERE id = '.$output['productid']);

		$status = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_ticket_status
			WHERE id = '.$output['status']);

				$array[] = array(
                'id' => $output['id'],
                'department' => $department['name'],
                'product' => $product['name'],
                'title' => $output['title'],
                'message' => $this->LimitTextOutput(strip_tags($output['bodytext']),$limit = 150),
                'created' => $output['created'],
                'updated' => $output['updated'],
                'status' => $status['name'],
                'statusid' => $output['status']
                );
		  

            }

  return $array;
}

    public function getCountMyTickets(array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_tickets`
		WHERE userid =  ".$userid));

		return $total;
    }

    public function getOpenMyTicket($userid,$id)
	{
		$this->_getDb()->fetchRow('
					UPDATE microsupport_tickets SET
						needaction = 1,
						status = 1
						 WHERE id = '.$id.' AND userid = '.$userid.'
				');
	}

    public function getTOpenMyTicket($userid,$id)
	{
		$this->_getDb()->fetchRow('
					UPDATE microsupport_tickets SET
						needaction = 1,
						status = 1
						 WHERE id = '.$id.'
				');
	}

    public function getCloseMyTicket($userid,$id)
	{
		$this->_getDb()->fetchRow('
					UPDATE microsupport_tickets SET
						needaction = 0,
						status = 3
						 WHERE id = '.$id.' AND userid = '.$userid.'
				');
	}

    public function getTCloseMyTicket($userid,$id)
	{
		$this->_getDb()->fetchRow('
					UPDATE microsupport_tickets SET
						needaction = 0,
						status = 3
						 WHERE id = '.$id.'
				');
	}

    public function getDeleteMyTicket($userid,$id)
	{
		$this->_getDb()->fetchRow('
					DELETE FROM microsupport_tickets WHERE id = '.$id.' AND userid = '.$userid.'
				');
	}

    public function getTDeleteMyTicket($userid,$id)
	{
		$this->_getDb()->fetchRow('
					DELETE FROM microsupport_tickets WHERE id = '.$id.'
				');
	}

    public function getDeletefaq($id)
	{
		$this->_getDb()->fetchRow('
					DELETE FROM microsupport_faq WHERE id = '.$id.'
				');
	}

    public function getDeleteNews($id)
	{
		$this->_getDb()->fetchRow('
					DELETE FROM microsupport_news WHERE id = '.$id.'
				');
	}

    public function GetTicket($ticketid)
    {

  $array = array();
  
  $output = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_tickets
			LEFT JOIN xf_user ON 
			(xf_user.user_id = microsupport_tickets.userid)
			WHERE id = ?
		', $ticketid);

		return $output;

    }

    public function UpdateTicketStstus($id, $option)
	{
		$this->_getDb()->fetchRow('
					UPDATE microsupport_tickets SET
						'.$option.'
						 WHERE id = '.$id.'
				');
	}

	public function GetSupportTechnician(array $viewingUser = null){

        $this->standardizeViewingUserReference($viewingUser);

        return XenForo_Permission::hasPermission($viewingUser['permissions'], 'microsupport', 'microsupporttechnician');

    }

	public function CanAccessMicroSupport(array $viewingUser = null){

        $this->standardizeViewingUserReference($viewingUser);

        return XenForo_Permission::hasPermission($viewingUser['permissions'], 'microsupport', 'microsupportaccess');

    }

	public function CanAddNewTicket(array $viewingUser = null){

        $this->standardizeViewingUserReference($viewingUser);

        return XenForo_Permission::hasPermission($viewingUser['permissions'], 'microsupport', 'microsupportaddticket');

    }

    public function getRecordById($tablename, $id, $rowname = 'id')
    {

	$info = $this->_getDb()->fetchRow('
            SELECT *
            FROM '.$tablename.' 
			WHERE '.$rowname.'='.$id.'
        ');

        return $info;
    }

    public function getAllextrafieldsbit($id)
    {
	$output = array();

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_ticket_fields 
			WHERE ticketid='.$id.'
        ');

		foreach($infos AS $row => $info)
		{
			$textvalue = $this->getRecordById("microsupport_fields",$info["fieldid"]);
			$output[] = array(
                'id' => $info['id'],
                'fieldid' => $info['fieldid'],
                'ticketid' => $info['ticketid'],
                'title' => $textvalue['title'],
                'textvalue' => $info['textvalue'],
                );
		}

        return $output;
    }

    public function getAllTicketReplies($id,$userid,$perpage,$page)
    {
	$output = array();

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_ticket_replies 
			LEFT JOIN xf_user ON 
			(xf_user.user_id = microsupport_ticket_replies.userid)
			WHERE ticketid='.$id.'
			ORDER BY created ASC
			LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($infos AS $row => $info)
		{
           if($info["userid"] == $userid)
           {
              $iconfile = "client.gif";
           } else {
              $iconfile = "tech.gif";
           }
           if($info["username"] == '')
           {
              $info["username"] = "Guest";
           } else {
              $info["username"] = $info["username"];
           }

		$avatarinfos = XenForo_Template_Helper_Core::getAvatarUrls($info);

			$avatarUrl = $avatarinfos['s'];
			$output[] = array(
                'id' => $info['id'],
                'ticketid' => $info['ticketid'],
                'userid' => $info['userid'],
                'username' => $info['username'],
                'user_id' => $info['user_id'],
                'avatar' => $avatarUrl,
                'message' => stripslashes($info['bodytext']),
                'attachment' => $info['attachment'],
                'created' => $info['created'],
                'iconfile' => $iconfile,
                );
		}

        return $output;
    }

	public function GetSupportAttach(array $viewingUser = null){

        $this->standardizeViewingUserReference($viewingUser);

        return XenForo_Permission::hasPermission($viewingUser['permissions'], 'microsupport', 'microsupportattachfiles');

    }

    public function getAllPrelist($prewhere)
    {
	$output = array();

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_predefinied 
			'.$prewhere.'
			 ORDER BY title ASC
        ');

		foreach($infos AS $row => $info)
		{
	$bbCodeParser = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));

		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));
		$info['message'] = new XenForo_BbCode_TextWrapper($info['message'], $bbCodeParserHtml);
		$info['message'] = XenForo_Helper_String::autoLinkBbCode($info['message']);
			$output[] = array(
                'id' => $info['id'],
                'departmentid' => $info['departmentid'],
                'productid' => $info['productid'],
                'title' => $info['title'],
                'message' => $info['message'],
                );
		}

        return $output;
    }

    public function doTicketsub($id, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		$this->_getDb()->fetchRow('INSERT INTO microsupport_subscribe
                                    SET tid = '.$id.',
                                        uid = '.$userid.'
				');
	}

	public function SaveTicketReply($input)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_ticket_replies
                                 SET bodytext="'.$input['bodytext'].'",
                                     ticketid='.$input['id'].',
                                     attachment="'.$input['flyer_name'].'",
                                     userid='.$input['userid'].',
                                     created='.$input['created'].'');
			$lastInsertId = $this->_getDb()->lastInsertId();				 
			return $lastInsertId;
	}

	public function SavePredefinied($predefinied)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_predefinied
                                    SET departmentid = '.$predefinied['department'].',
                                        productid = '.$predefinied['product'].',
                                        title = "'.$predefinied['pretitle'].'",
                                        message = "'.$predefinied['message'].'"');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function UpdatePredefiniedStats($ticketid)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_pre_stats SET ticketid='.$ticketid.'');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function SaveFAQS($transfer)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_faq
                                      SET categoryid = '.$transfer['categoryid'].',
                                          question = "'.$transfer['faqtitle'].'",
                                          answer = "'.$transfer['answer'].'",
                                          created = '.$transfer['created'].',
                                          important = '.$transfer['important'].'');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function UpdateFAQS($transfer)
	{
		$this->_getDb()->fetchRow('UPDATE microsupport_faq
                                      SET categoryid = '.$transfer['categoryid'].',
                                          question = "'.$transfer['faqtitle'].'",
                                          answer = "'.$transfer['answer'].'",
                                          created = '.$transfer['created'].',
                                          important = '.$transfer['important'].'
										  WHERE id='.$transfer['id']);
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function UpdatePredefinied($predefinied)
	{
		$this->_getDb()->fetchRow('UPDATE microsupport_predefinied
                                    SET departmentid = '.$predefinied['department'].',
                                        productid = '.$predefinied['product'].',
                                        title = "'.$predefinied['pretitle'].'",
                                        message = "'.$predefinied['message'].'"
										WHERE id='.$predefinied['id']);
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

    public function getDeletepre($id)
	{
		$this->_getDb()->fetchRow('
					DELETE FROM microsupport_predefinied WHERE id = '.$id.'
				');
	}

	public function UpdateFAQStats($ticketid)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_faq_stats SET ticketid='.$ticketid.'');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function SaveAndUpdateReply($status,$needaction,$updated,$ticketid)
	{
		$this->_getDb()->fetchRow('UPDATE microsupport_tickets
                                 SET status='.$status.',
                                     needaction='.$needaction.',
                                     updated='.$updated.' WHERE id='.$ticketid);
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function AlertreportuseauthorByID(array $Ids)
	{
		return $this->fetchAllKeyed('
			SELECT
			*
			FROM microsupport_tickets
			WHERE id IN (' . $this->_getDb()->quote($Ids) . ')
		', 'id');
	}

	public function SubscribeAlert($id)
	{

$ticketinfo = $this->_getDb()->fetchRow("SELECT * FROM microsupport_tickets WHERE id=".$id."");

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_subscribe 
			LEFT JOIN xf_user ON 
			(xf_user.user_id = microsupport_subscribe.uid)
			WHERE tid = '.$id.'
        ');

		foreach($infos AS $row => $info)
		{
		$departmentinfo = $this->_getDb()->fetchRow("SELECT * FROM microsupport_departments WHERE id=".$ticketinfo['departmentid']."");
$tecinfo = $this->_getDb()->fetchRow("SELECT * FROM xf_user WHERE email='".$departmentinfo['emails']."'");

				XenForo_Model_Alert::alert(
							$info['user_id'],
							$tecinfo['user_id'], 
							$tecinfo['username'],
							'microsupport',
							$id,
							'subsupdatetechnician'
						);
		}

	}

	public function AlertUserTicketHolder($id, $iserid)
	{

$ticketinfo = $this->_getDb()->fetchRow("SELECT * FROM microsupport_tickets WHERE id=".$id."");

$tecinfo = $this->_getDb()->fetchRow("SELECT * FROM xf_user WHERE user_id='".$iserid."'");

				XenForo_Model_Alert::alert(
							$ticketinfo['userid'],
							$tecinfo['user_id'], 
							$tecinfo['username'],
							'microsupport',
							$id,
							'subsupdateath'
						);

	}

	public function AlertDepartmentTecs($id, $iserid, $owner, $isguest)
	{

$ticketinfo = $this->_getDb()->fetchRow("SELECT * FROM microsupport_tickets WHERE id=".$id."");

$tecinfo = $this->_getDb()->fetchRow("SELECT * FROM xf_user WHERE user_id='".$iserid."'");
if($isguest == 0){
$ownerinfo = $this->_getDb()->fetchRow("SELECT * FROM xf_user WHERE user_id='".$owner."'");
}else{
			$session = XenForo_Application::get('session');
			//print_r($session);
		$userid = preg_replace('#[^0-9]#', '', $session->get('ip'));
	$ownerinfo['user_id'] = $userid;
	$ownerinfo['username'] = 'Guest';
}

				XenForo_Model_Alert::alert(
							$tecinfo['user_id'],
							$ownerinfo['user_id'], 
							$ownerinfo['username'],
							'microsupport',
							$id,
							'subsupdatedment'
						);

	}

    public function getRecordByEmail($tablename, $id, $rowname = 'email')
    {

	$info = $this->_getDb()->fetchRow('
            SELECT *
            FROM '.$tablename.' 
			WHERE '.$rowname.'="'.$id.'"
        ');

        return $info;
    }

    public function getCountTicketReplies($id)
	{

		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_ticket_replies`
		WHERE ticketid = ".$id));

		return $total;
    }

	public function UpdateNewReply($ticketid)
	{
		$this->_getDb()->fetchRow('UPDATE microsupport_tickets
                                 SET newreply=1 WHERE id='.$ticketid);
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

    public function getDownloadByID($id, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

        $info = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_downloads
            WHERE id = ?
        ', $id);
	$bbCodeParser = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));

		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('Base'));
		$info['downloaddescription'] = new XenForo_BbCode_TextWrapper($info['downloaddescription'], $bbCodeParserHtml);

        $aloud_usergroups = explode(",", $info['downloadusergroups']);

		$secondaryUsergroups = array_merge(array((string)$viewingUser['user_group_id']), (explode(',', $viewingUser['secondary_group_ids'])));
		$info['isaloud'] = false;
		foreach ($secondaryUsergroups AS $groupId){

          if (in_array($groupId, $aloud_usergroups))
          {
			$info['isaloud'] = true;
          }
		  }

        return $info ? $info : false;
    }

    public function admingetDownloadByID($id, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

        $info = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_downloads
            WHERE id = ?
        ', $id);

        $aloud_usergroups = explode(",", $info['downloadusergroups']);

		$secondaryUsergroups = array_merge(array((string)$viewingUser['user_group_id']), (explode(',', $viewingUser['secondary_group_ids'])));
		$info['isaloud'] = false;
		foreach ($secondaryUsergroups AS $groupId){

          if (in_array($groupId, $aloud_usergroups))
          {
			$info['isaloud'] = true;
          }
		  }

        return $info ? $info : false;
    }

	public function UpdateDownloadCountByID($id)
	{
		$this->_getDb()->fetchRow('UPDATE microsupport_downloads
                      SET downloadcount=downloadcount+1 WHERE id='.$id);
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

public function listMainCategories($settings,$perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

	$changeline = 0;
$blocks = 3;
    $blockwidth = 100 / $blocks;
    $blockwidth = $blockwidth.'%';
  $array = array();
			$isaloud = false;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_categories WHERE parentid=0 ORDER BY displayorder ASC, name ASC LIMIT ' .($page - 1) * $perpage .','.$perpage);

    $idx = 1;
		foreach($sql_output AS $row => $output)
            {
				$array[] = array(
                'id' => $output['id'],
                'parentid' => $output['parentid'],
                'name' => $output['name'],
                'displayorder' => $output['displayorder'],
                'changeline' => $changeline,
				'blockwidth' => $blockwidth,
				'subcatcount' => $this->getCountAllSubCats($output['id']),
				'itemcountcount' => $this->getCountAllItemCats($output['id'])
                );
          if($idx == 3) {
             $changeline = 1;
             $idx = 0;
          } else {
             $changeline = 0;
          }
          $idx++;
            }

  return $array;
}

    public function getCountAllMainCats()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_categories` WHERE parentid=0"));

		return $total;
    }

    public function getCountAllItemCats($id)
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_faq` WHERE categoryid=".$id));

		return $total;
    }

    public function getCountAllSubCats($parentid)
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_categories` WHERE parentid=".$parentid));

		return $total;
    }

    public function getkbCategoryByID($id)
    {
        $cat = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_categories
            WHERE id = ?
        ', $id);

        return $cat ? $cat : false;
    }

public function listSubCategories($catid, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

	$changeline = 0;
$blocks = 3;
    $blockwidth = 100 / $blocks;
    $blockwidth = $blockwidth.'%';
  $array = array();
			$isaloud = false;

		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_categories WHERE parentid='.$catid.' ORDER BY displayorder ASC, name ASC');

    $idx = 1;
		foreach($sql_output AS $row => $output)
            {
				$array[] = array(
                'id' => $output['id'],
                'parentid' => $output['parentid'],
                'name' => $output['name'],
                'displayorder' => $output['displayorder'],
                'changeline' => $changeline,
				'blockwidth' => $blockwidth,
				'subcatcount' => $this->getCountAllSubCats($output['id']),
				'itemcountcount' => $this->getCountAllItemCats($output['id'])
                );
          if($idx == 3) {
             $changeline = 1;
             $idx = 0;
          } else {
             $changeline = 0;
          }
          $idx++;
            }

  return $array;
}

public function listCategoryItems($catid,$perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

  $array = array();
			$isaloud = false;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_faq WHERE categoryid='.$catid.' ORDER BY created ASC LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {
				$array[] = array(
                'id' => $output['id'],
                'question' => $output['question'],
                'created' => $output['created']
                );
            }

  return $array;
}

    public function getCountAllCats()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_categories`"));

		return $total;
    }

    public function getCountAllDepartments()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_departments`"));

		return $total;
    }

    public function getCountAllDownloads()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_downloads`"));

		return $total;
    }

    public function getCountAllFAQs()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_faq`"));

		return $total;
    }

    public function getCountAllPredefinied()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_predefinied`"));

		return $total;
    }

    public function getCountAllPoducts()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_products`"));

		return $total;
    }

    public function getCountAllTickets()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_tickets`"));

		return $total;
    }

    public function uploadFile($filea)
    {

	$settings = $this->adminSettingsinfo(1);
	$errors=0;
	$downloadfolder = $settings['microsupport_upload_path'];
			$filesaloud = explode(",", $settings['upload_types']);
			if(!empty($filea["name"])){
        		if($filea["error"] == UPLOAD_ERR_OK){
           			$extension = $this->getExtension($filea["name"]);
					if (in_array($extension,$filesaloud)){
  					}
				}else{

  				}
			@unlink($downloadfolder . $filea["name"]);
           	$filename = $this->stripext($filea["name"]);
           	$filename = str_replace (" ", "_", $filename);
           	$filename = str_replace ("-", "", $filename);
           	$filename = str_replace (".", "", $filename);
           	$filename = str_replace ("'", "", $filename);
           	$time = time();
           	$productfilename = $filename.'_'.time().'_'.rand(1, 5000).'.'.$extension;
           	//rename($filea["tmp_name"], $downloadfolder . $productfilename);
			$productfilename = $this->LimitTextOutput($productfilename,$limit = 150);
			move_uploaded_file($filea["tmp_name"], $downloadfolder . $productfilename);
			return $productfilename;

			} else {
			}
	}

	public function fileExtension($filename){
  		$path_info = pathinfo($filename);
  		return $path_info['extension'];
	}

	public function getExtension($str) {

         $i = strrpos($str,".");
         if (!$i) { return ""; } 

         $l = strlen($str) - $i;
         $ext = substr($str,$i+1,$l);
         return $ext;
 }

public function findext($filename)
{
  $filename = strtolower($filename) ;
  $exts = split("[/\\.]", $filename) ;
  $exts = $exts[count($exts)-1];

  return $exts;
}

public function stripext($name)
{
  $ext = strrchr($name, '.');
  if($ext !== false)
    $name = substr($name, 0, -strlen($ext));

  return $name;
}

    public function AdminlistallFiles($fetchOptions)
    {

	if($fetchOptions['page'] == 0 || $fetchOptions['page'] == ''){
		$fetchOptions['offset'] = 0;
	}else{
		$fetchOptions['offset'] = $fetchOptions['perPage'];
	}

	$max = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];

        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_downloads
            ORDER BY downloaddate DESC
			'.$max.'
        ', 'id');
    }

    public function AdminlistallTicketstatus()
    {

        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_ticket_status
            ORDER BY displayorder ASC
        ', 'id');
    }

    public function admingetTicketstatusByID($id)
    {
        $ad = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_ticket_status
            WHERE id = ?
        ', $id);

        return $ad ? $ad : false;
    }

    public function getCountExtrafields()
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_fields`"));

		return $totalproducts;
    }

    public function AdminlistallExtrafields($fetchOptions)
    {

	if($fetchOptions['page'] == 0 || $fetchOptions['page'] == ''){
		$fetchOptions['offset'] = 0;
	}else{
		$fetchOptions['offset'] = $fetchOptions['perPage'];
	}

	$max = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];

        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_fields
            ORDER BY displayorder
			'.$max.'
        ', 'id');
    }

    public function admingetExtrafieldByID($id)
    {
        $ad = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_fields
            WHERE id = ?
        ', $id);

        return $ad ? $ad : false;
    }

    public function getCountproducts()
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_products`"));

		return $totalproducts;
    }

    public function Adminlistallproducts($fetchOptions)
    {

	if($fetchOptions['page'] == 0 || $fetchOptions['page'] == ''){
		$fetchOptions['offset'] = 0;
	}else{
		$fetchOptions['offset'] = $fetchOptions['perPage'];
	}

	$max = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];

        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_products
            ORDER BY displayorder
			'.$max.'
        ', 'id');
    }

    public function admingetProductByID($id)
    {
        $ad = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_products
            WHERE id = ?
        ', $id);

        return $ad ? $ad : false;
    }

    public function getCountDepartments()
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_departments`"));

		return $totalproducts;
    }

    public function AdminlistallDepartments($fetchOptions)
    {

	if($fetchOptions['page'] == 0 || $fetchOptions['page'] == ''){
		$fetchOptions['offset'] = 0;
	}else{
		$fetchOptions['offset'] = $fetchOptions['perPage'];
	}

	$max = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];

        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_departments
            ORDER BY displayorder
			'.$max.'
        ', 'id');
    }

    public function admingetDepartmentByID($id)
    {
        $ad = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_departments
            WHERE id = ?
        ', $id);

        return $ad ? $ad : false;
    }

    public function getCountCategories()
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_categories`"));

		return $totalproducts;
    }

    public function AdminlistallCategories($fetchOptions)
    {

	if($fetchOptions['page'] == 0 || $fetchOptions['page'] == ''){
		$fetchOptions['offset'] = 0;
	}else{
		$fetchOptions['offset'] = $fetchOptions['perPage'];
	}

	$max = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];
	$array = array();
	$sql_output = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_categories
			WHERE parentid = 0
            ORDER BY displayorder ASC
			'.$max.'
        ', 'id');

		foreach($sql_output AS $row => $output){

			$array[] = array(
                'id' => $output['id'],
                'parentid' => $output['parentid'],
                'name' => $output['name'],
                'displayorder' => $output['displayorder'],
                'depth' => $output['depth']
                );

			$subcats = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_categories
			WHERE parentid = '.$output['id'].'
            ORDER BY displayorder ASC
        ', 'id');

		foreach($subcats AS $subrow => $subcat){

			$array[] = array(
                'id' => $subcat['id'],
                'parentid' => $subcat['parentid'],
                'name' => $subcat['name'],
                'displayorder' => $subcat['displayorder'],
                'depth' => $subcat['depth']
                );

			$subsubcats = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_categories
			WHERE parentid = '.$subcat['id'].'
            ORDER BY displayorder ASC
        ', 'id');

		foreach($subsubcats AS $subsubrow => $subsubcat){

			$array[] = array(
                'id' => $subsubcat['id'],
                'parentid' => $subsubcat['parentid'],
                'name' => $subsubcat['name'],
                'displayorder' => $subsubcat['displayorder'],
                'depth' => $subsubcat['depth']
                );

			$subsubsubcats = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_categories
			WHERE parentid = '.$subsubcat['id'].'
            ORDER BY displayorder ASC
        ', 'id');

		foreach($subsubsubcats AS $subsubsubrow => $subsubsubcat){

			$array[] = array(
                'id' => $subsubsubcat['id'],
                'parentid' => $subsubsubcat['parentid'],
                'name' => $subsubsubcat['name'],
                'displayorder' => $subsubsubcat['displayorder'],
                'depth' => $subsubsubcat['depth']
                );

		}

		}

		}
		  
          }

        return $array;
    }

    public function admingetFAQCatByID($id)
    {
        $ad = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_categories
            WHERE id = ?
        ', $id);

        return $ad ? $ad : false;
    }

    public function AdminlistallFAQCategories()
    {

	$array = array();
	$sql_output = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_categories
			WHERE parentid = 0
            ORDER BY displayorder ASC
        ', 'id');

		foreach($sql_output AS $row => $output){

			$array[] = array(
                'id' => $output['id'],
                'parentid' => $output['parentid'],
                'name' => $output['name'],
                'displayorder' => $output['displayorder'],
                'depth' => $output['depth']
                );

			$subcats = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_categories
			WHERE parentid = '.$output['id'].'
            ORDER BY displayorder ASC
        ', 'id');

		foreach($subcats AS $subrow => $subcat){

			$array[] = array(
                'id' => $subcat['id'],
                'parentid' => $subcat['parentid'],
                'name' => '->'.$subcat['name'],
                'displayorder' => $subcat['displayorder'],
                'depth' => $subcat['depth']
                );

			$subsubcats = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_categories
			WHERE parentid = '.$subcat['id'].'
            ORDER BY displayorder ASC
        ', 'id');

		foreach($subsubcats AS $subsubrow => $subsubcat){

			$array[] = array(
                'id' => $subsubcat['id'],
                'parentid' => $subsubcat['parentid'],
                'name' => '-->'.$subsubcat['name'],
                'displayorder' => $subsubcat['displayorder'],
                'depth' => $subsubcat['depth']
                );

		}

		}
		  
          }

        return $array;
    }

public function getTechTickets($perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

  $array = array();
			$isaloud = false;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_tickets
	                        WHERE needaction=1 AND status<>3
                            ORDER BY priority ASC, updated ASC
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {
          $emails = $this->getRecordById("microsupport_departments",$output['departmentid']);
          if(!empty($emails["emails"]))
          {
              $toemails = explode(",", $emails['emails']);
              foreach($toemails AS $toemail)
              {
				  
				  if($viewingUser['email'] == $toemail){
		$output['bodytext'] = stripslashes($output['bodytext']);

		$output['bodytext'] = XenForo_Helper_String::autoLinkBbCode($output['bodytext']);

		$department = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_departments
			WHERE id = '.$output['departmentid']);

		$product = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_products
			WHERE id = '.$output['productid']);

		$status = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_ticket_status
			WHERE id = '.$output['status']);


		$userinfo = $this->_getDb()->fetchRow("
			SELECT * 
			FROM xf_user 
			WHERE user_id='".$output['userid']."'");

				$array[] = array(
                'id' => $output['id'],
                'department' => $department['name'],
                'product' => $product['name'],
                'username' => $userinfo['username'],
                'title' => $output['title'],
                'message' => $this->LimitTextOutput(strip_tags($output['bodytext']),$limit = 150),
                'created' => $output['created'],
                'updated' => $output['updated'],
                'status' => $status['name'],
                'statusid' => $output['status']
                );
				  }
			  }
		  }

            }

        return $array ? $array : false;
}

    public function getCountTechTickets(array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		$total = count($this->_getDb()->fetchAll("SELECT * FROM microsupport_tickets AS microsupport_tickets
		WHERE needaction=1 AND status<>3"));

		return $total;
    }

    public function AdminlistallTDepartments()
    {

        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_departments
            ORDER BY displayorder
        ', 'id');
    }

    public function AdminlistallTproducts()
    {

        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_products
            ORDER BY displayorder
        ', 'id');
    }

public function getSearchTechTickets($where,$perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

  $array = array();
			$isaloud = false;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_tickets
	                        WHERE '.$where.'
                            ORDER BY priority ASC, updated ASC
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {
          $emails = $this->getRecordById("microsupport_departments",$output['departmentid']);
          if(!empty($emails["emails"]))
          {
              $toemails = explode(",", $emails['emails']);
              foreach($toemails AS $toemail)
              {
				  
				  if($viewingUser['email'] == $toemail){
		$output['bodytext'] = stripslashes($output['bodytext']);

		$output['bodytext'] = XenForo_Helper_String::autoLinkBbCode($output['bodytext']);

		$department = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_departments
			WHERE id = '.$output['departmentid']);

		$product = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_products
			WHERE id = '.$output['productid']);

		$status = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_ticket_status
			WHERE id = '.$output['status']);


		$userinfo = $this->_getDb()->fetchRow("
			SELECT * 
			FROM xf_user 
			WHERE user_id='".$output['userid']."'");

				$array[] = array(
                'id' => $output['id'],
                'department' => $department['name'],
                'product' => $product['name'],
                'username' => $userinfo['username'],
                'title' => $output['title'],
                'message' => $this->LimitTextOutput(strip_tags($output['bodytext']),$limit = 150),
                'created' => $output['created'],
                'updated' => $output['updated'],
                'status' => $status['name'],
                'statusid' => $output['status']
                );
				  }
			  }
		  }

            }

        return $array ? $array : false;
}

    public function getCountSearchTechTickets($where,array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		$total = count($this->_getDb()->fetchAll("SELECT * FROM microsupport_tickets AS microsupport_tickets
		WHERE ".$where));

		return $total;
    }

public function getTechFaqs($perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_faq
	                        ORDER BY id DESC
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

  return $sql_output;
}

    public function getCountTechFaqs(array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		$total = count($this->_getDb()->fetchAll("SELECT * FROM microsupport_faq"));

		return $total;
    }

public function getTechListpre($perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

  $array = array();
			$isaloud = false;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_predefinied
	                        ORDER BY id DESC
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {

		$department = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_departments
			WHERE id = '.$output['departmentid']);

		$product = $this->_getDb()->fetchRow('
			SELECT *
			FROM microsupport_products
			WHERE id = '.$output['productid']);

				$array[] = array(
                'id' => $output['id'],
                'department' => $department['name'],
                'product' => $product['name'],
                'title' => $this->LimitTextOutput(strip_tags($output['title']),$limit = 50)
                );

			}

  return $array;
}

    public function getCountTechListpre(array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$userid = $viewingUser['user_id'];

		$total = count($this->_getDb()->fetchAll("SELECT * FROM microsupport_predefinied"));

		return $total;
    }

    public function listMessages($order = 'title')
    {
        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_messages
            ORDER BY ' . $order . '
        ', 'id');
    }

    public function listUserGroups($order = 'title')
    {
        return $this->fetchAllKeyed('
            SELECT *
            FROM xf_user_group
            ORDER BY ' . $order . '
        ', 'user_group_id');
    }

	public function getSeconderyUsergroups($selectedgroups)
	{

		if (!empty($selectedgroups))
		{
			$userSecondaryGroups = explode(',', $selectedgroups);
		}
		else
		{
			$userSecondaryGroups = array();
		}
		$userGroups = $this->_getUserGroupModel()->getAllUserGroupTitles();

		$secondaryGroups = array();
		foreach ($userGroups AS $userGroupId => $title)
		{
			$secondaryGroups[] = array(
				'label' => $title,
				'value' => $userGroupId,
				'selected' => in_array($userGroupId, $userSecondaryGroups)
			);
		}
		return $secondaryGroups;
	}

	protected function _getUserGroupModel()
	{
		return $this->getModelFromCache('XenForo_Model_UserGroup');
	}

public function LimitTextOutput($text,$limit = 0)
{
  if($limit != 0) {
  	if(strlen($text) > $limit)
  		$text = substr($text, 0, $limit).' ...';
  	}
    return $text;
}

    public function microsupport_users_online($userid)
    {

        $info = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_users_online WHERE userid = ?
        ', $userid);

        return $info ? $info : false;
    }

	public function microsupport_insert_users_online($userid,$fname,$usergroupID,$email,$timeout)
	{
		$this->_getDb()->fetchRow("INSERT INTO microsupport_users_online (userid, username, usergroupID, email, timeout) 
        VALUES('".$userid."','".$fname."','".$usergroupID."','".$email."','".$timeout."')");
	}

	public function microsupport_update_adminstatus($userid, $status)
	{
		$this->_getDb()->fetchRow("UPDATE microsupport_supportusers_online SET `admininchat` = ".$status." WHERE `supportuserid` = ".$userid);
	}

	public function microsupport_delete_users_online($userid)
	{
		$this->_getDb()->fetchRow("DELETE FROM microsupport_support_chats WHERE usersid=".$userid);
	}

    public function microsupport_supportusers_online()
    {

        $info = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_supportusers_online ORDER BY supportuserstatus ASC
        ');

        return $info ? $info : false;
    }

    public function microsupport_modsupportadvisers_onlineadmin($userid)
    {

        $info = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_supportusers_online 
			WHERE supportuserid = '.$userid.'
        ');
		if($info['supportuserid'] == false){
			$output = false;
		}else{
	$output = array();
			$supportuserinfo = $this->_getDb()->fetchRow('
            SELECT *
            FROM xf_user WHERE user_id = '.$info['supportuserid'].'
        ');
			$output[] = array(
                'supportuserid' => $info['supportuserid'],
                'supportusername' => $supportuserinfo['username'],
                'usersUID' => $info['usersUID'],
                'supportuserstatus' => $info['supportuserstatus'],
                'admininchat' => $info['admininchat'],
                'supportusertimeout' => $info['supportusertimeout'],
                'perrow' => 1,
                );
		}

        return $output ? $output : false;
    }

    public function microsupport_supportadvisers_onlineadmin($userid)
    {

        $info = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_supportusers_online 
			WHERE supportuserid = '.$userid.'
        ');

        return $info ? $info : false;
    }

    public function microsupport_supportadvisers_online()
    {
	$output = array();

	$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_supportusers_online 
			ORDER BY supportuserstatus ASC
        ');
		$i=1;
		foreach($infos AS $row => $info)
		{
			$supportuserinfo = $this->_getDb()->fetchRow('
            SELECT *
            FROM xf_user WHERE user_id = '.$info['supportuserid'].'
        ');
			$output[] = array(
                'supportuserid' => $info['supportuserid'],
                'supportusername' => $supportuserinfo['username'],
                'usersUID' => $info['usersUID'],
                'supportuserstatus' => $info['supportuserstatus'],
                'admininchat' => $info['admininchat'],
                'supportusertimeout' => $info['supportusertimeout'],
                'perrow' => $i,
                );
				if($i == 3){
					$i = 1;
				}else{
				$i++;
				}
		}

        return $output;
    }

	public function microsupport_adminlogout_online($adminID)
	{
		$this->_getDb()->fetchRow("DELETE FROM microsupport_supportusers_online WHERE supportuserid = ".$adminID);
	}

	public function microsupport_adminlogin_online($adminID,$supportusertimeout)
	{
		$this->_getDb()->fetchRow("INSERT INTO microsupport_supportusers_online (supportuserid, usersUID, supportuserstatus, admininchat, supportusertimeout) 
        VALUES('".$adminID."','0','1','0','".$supportusertimeout."')");
	}

	public function microsupport_dochat_online($adminID,$usersUID,$supportusertimeout)
	{
		$this->_getDb()->fetchRow("UPDATE microsupport_supportusers_online SET `supportuserstatus` = 2, `usersUID` = " . $usersUID . " WHERE `supportuserid` = ".$adminID);
	}

	public function microsupport_dochatlogout_online($usersUID,$adminid)
	{
		$this->_getDb()->fetchRow("UPDATE microsupport_supportusers_online SET `supportuserstatus` = 1, `usersUID` = 0 WHERE `usersUID` = ".$usersUID);
		$this->_getDb()->fetchRow("DELETE FROM microsupport_users_online WHERE userid = ".$usersUID);
		$this->_getDb()->fetchRow("DELETE FROM microsupport_users_online WHERE userid = ".$adminid);
	}

    public function microsupport_supportadminlistlist_online()
    {

  $array = array();
  
  $output = $this->_getDb()->fetchAll('
			SELECT *
			FROM microsupport_supportusers_online
			WHERE supportuserstatus = 1
		');

		return $output;

    }

    public function getCountChatbgs()
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_chat_backgrounds`"));

		return $totalproducts;
    }

    public function microsupport_admin_get_bgs($where,$limit)
	{


        return $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_chat_backgrounds
			'.$where.'
            ORDER BY id
			'.$limit.'
        ', 'id');
}

	public function _GetChatbg($id)
	{
		return $this->_getDb()->fetchRow("SELECT *
			FROM microsupport_chat_backgrounds WHERE id = ".$id);
	}

	public function _Getuserinfo($usersUID)
	{
		return $this->_getDb()->fetchRow("SELECT *
			FROM xf_user WHERE user_id = ".$usersUID);
	}

    public function _Getuserinformation($xfUser_Id, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);
  $array = array();

			$array[] = array(
				'user_id' => $viewingUser['user_id'],
				'user_group_id' => $viewingUser['user_group_id']
			);

		return $array;

    }

    public function microsupport_getguest_ipaddress()
    {

			$ipaddress = '';
			$HTTP_CLIENT_IP = (isset($_SERVER['HTTP_CLIENT_IP']) ? $_SERVER['HTTP_CLIENT_IP'] : '');
			$HTTP_X_FORWARDED_FOR = (isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : '');
			$HTTP_X_FORWARDED = (isset($_SERVER['HTTP_X_FORWARDED']) ? $_SERVER['HTTP_X_FORWARDED'] : '');
			$HTTP_FORWARDED_FOR = (isset($_SERVER['HTTP_FORWARDED_FOR']) ? $_SERVER['HTTP_FORWARDED_FOR'] : '');
			$HTTP_FORWARDED = (isset($_SERVER['HTTP_FORWARDED']) ? $_SERVER['HTTP_FORWARDED'] : '');
			$REMOTE_ADDR = (isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '');
    if ($HTTP_CLIENT_IP){
        $ipaddress = $HTTP_CLIENT_IP;
	}else if($HTTP_X_FORWARDED_FOR){
        $ipaddress = $HTTP_X_FORWARDED_FOR;
	}else if($HTTP_X_FORWARDED){
        $ipaddress = $HTTP_X_FORWARDED;
	}else if($HTTP_FORWARDED_FOR){
        $ipaddress = $HTTP_FORWARDED_FOR;
	}else if($HTTP_FORWARDED){
        $ipaddress = $HTTP_FORWARDED;
	}else if($REMOTE_ADDR){
        $ipaddress = $REMOTE_ADDR;
	}else{
			$ipaddress = 'none';
	}
	//$ipaddress=str_replace(".","",$ipaddress);
	//$ipaddress=trim($ipaddress);
	$ipaddress = ip2long($ipaddress);

        return $ipaddress ? $ipaddress : false;
    }

    public function microsupport_mapuser_ipaddress()
    {

			$ipaddress = '';
			$HTTP_CLIENT_IP = (isset($_SERVER['HTTP_CLIENT_IP']) ? $_SERVER['HTTP_CLIENT_IP'] : '');
			$HTTP_X_FORWARDED_FOR = (isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : '');
			$HTTP_X_FORWARDED = (isset($_SERVER['HTTP_X_FORWARDED']) ? $_SERVER['HTTP_X_FORWARDED'] : '');
			$HTTP_FORWARDED_FOR = (isset($_SERVER['HTTP_FORWARDED_FOR']) ? $_SERVER['HTTP_FORWARDED_FOR'] : '');
			$HTTP_FORWARDED = (isset($_SERVER['HTTP_FORWARDED']) ? $_SERVER['HTTP_FORWARDED'] : '');
			$REMOTE_ADDR = (isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '');
    if ($HTTP_CLIENT_IP){
        $ipaddress = $HTTP_CLIENT_IP;
	}else if($HTTP_X_FORWARDED_FOR){
        $ipaddress = $HTTP_X_FORWARDED_FOR;
	}else if($HTTP_X_FORWARDED){
        $ipaddress = $HTTP_X_FORWARDED;
	}else if($HTTP_FORWARDED_FOR){
        $ipaddress = $HTTP_FORWARDED_FOR;
	}else if($HTTP_FORWARDED){
        $ipaddress = $HTTP_FORWARDED;
	}else if($REMOTE_ADDR){
        $ipaddress = $REMOTE_ADDR;
	}else{
			$ipaddress = 'none';
	}
	//$ipaddress=str_replace(".","",$ipaddress);
	//$ipaddress=trim($ipaddress);
	//$ipaddress = ip2long($ipaddress);

        return $ipaddress ? $ipaddress : false;
    }

    public function microsupport_admincpuser_list_online()
    {

        $info = $this->_getDb()->fetchAll('
            SELECT *
            FROM xf_user ORDER BY user_id
        ');

        return $info ? $info : false;
    }

    public function microsupport_getusers_online()
    {

        $info = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_users_online ORDER BY userid
        ');

        return $info ? $info : false;
    }

	public function microsupport_dolivelogout_online($usersUID)
	{
		$this->_getDb()->fetchRow("DELETE FROM microsupport_users_online WHERE userid = ".$usersUID);
		$this->_getDb()->fetchRow("DELETE FROM microsupport_supportusers_online WHERE supportuserid = ".$usersUID);
	}

	public function microsupport_livesupportsavefile_online($UsersID,$productfilename)
	{
		$this->_getDb()->fetchRow("INSERT INTO microsupport_support_chat_dl
                      SET uid=".$UsersID.",
                          dlfile='".$productfilename."',
                          downloaded=0,
                          active=1");
	}

	public function microsupport_supportdls_online($DLuserID)
	{
		return $this->_getDb()->fetchRow("SELECT *
			FROM microsupport_support_chat_dl WHERE uid='" . $DLuserID ."' AND active=1");
	}

    public function microsupport_request_replys_online($userID)
	{

		$total = count($this->_getDb()->fetchAll("SELECT * FROM microsupport_tickets WHERE userid = '".$userID."' AND newreply=1"));

		return $total;
    }

    public function microsupport_request_adviserreplys_online($userID)
	{

		$total = count($this->_getDb()->fetchAll("SELECT * FROM microsupport_tickets WHERE userid = '".$userID."' AND newticket=1"));

		return $total;
    }

	public function microsupport_admin_addnew_chat($adminsID,$userID,$chat_body,$newrealadminid)
	{
		$this->_getDb()->fetchRow('INSERT INTO microsupport_support_chats (usersid, adminsid, chat, datetime, isbot, realadminid) 
        VALUES('.$adminsID.','.$userID.',"'.$chat_body.'",now(),0,'.$newrealadminid.')');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

    public function microsupport_admin_get_chat($userID,$adminsID)
    {

        $info = $this->_getDb()->fetchAll("
            SELECT *
            FROM microsupport_support_chats WHERE (usersid='" . $userID ."' AND adminsid = '" . $adminsID . "') OR (usersid='" . $adminsID ."' AND adminsid = '" . $userID . "') ORDER BY datetime DESC");

        return $info ? $info : false;
    }

	public function microsupport_checkchatcall_request_chat($adminsID)
	{
		return $this->_getDb()->fetchRow("SELECT *
			FROM microsupport_supportusers_online WHERE supportuserid= ".$adminsID);
	}

	public function microsupport_user_addnew_chat($userID,$adminsID,$chat_body,$realadminid, $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

		$this->_getDb()->fetchRow('INSERT INTO microsupport_support_chats (usersid, adminsid, chat, datetime,isbot,realadminid) 
        VALUES('.$userID.','.$adminsID.',"'.addslashes($chat_body).'",now(),0,'.$realadminid.')');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function microsupport_checklastid($userID,$adminsID)
	{
		return $this->_getDb()->fetchRow("SELECT id
			FROM microsupport_support_chats WHERE (usersid='" . $userID ."' AND adminsid = '" . $adminsID . "') OR (usersid='" . $adminsID ."' AND adminsid = '" . $userID . "') ORDER BY id DESC");
	}

	public function microsupport_admin_add_archive($id,$adminsID,$userID,$body,$date_time)
	{

		$this->_getDb()->fetchRow('INSERT INTO microsupport_support_archive (cid, adminsid, userid, chat, datetime) 
        VALUES('.$id.','.$adminsID.',"'.$userID.'","'.$body.'","'.$date_time.'")');

		$this->_getDb()->fetchRow("DELETE FROM microsupport_support_chats WHERE id = ".$id);
	}

    public function microsupport_checkarchiveBYID($id)
    {
        $ad = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_support_archive
            WHERE cid = ?
        ', $id);

        return $ad ? $ad : false;
    }

    public function getCountChatarchives()
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_support_archive` GROUP BY userid"));

		return $totalproducts;
    }

    public function getCountUserChatarchives($userid, $adminid)
    {
		$totalproducts = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_support_archive` WHERE adminsid = ".$adminid." AND userid = ".$userid));

		return $totalproducts;
    }

    public function AdminlistallChatarchives($fetchOptions)
    {

	if($fetchOptions['page'] == 0 || $fetchOptions['page'] == ''){
		$fetchOptions['offset'] = 0;
	}else{
		$fetchOptions['offset'] = $fetchOptions['perPage'];
	}

	$max = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];

	$sql_output = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_support_archive
			 GROUP BY userid
			'.$max.'
        ', 'id');
		$array = array();
		foreach($sql_output AS $row => $output)
            {
		$adminname = $this->_Getuserinfo($output['adminsid']);
		$username = $this->_Getuserinfo($output['userid']);
				$array[] = array(
                'id' => $output['id'],
                'cid' => $output['cid'],
                'adminsid' => $output['adminsid'],
                'adminname' => $adminname['username'],
                'userid' => $output['userid'],
                'username' => $username['username'],
                'chat' => $output['chat'],
                'datetime' => $output['datetime'],
                'itemcount' => $this->getCountUserChatarchives($output['userid'],$output['adminsid'])
                );

			}

        return $array;
    }

    public function getbotinfo()
    {
		$botinfo = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_botname
            WHERE id = ?
        ', 1);
		$botinfo['uid'] = rand(99999 , 999999);

		return $botinfo;
    }

    public function microsupport_ajax_get_chat($userID,$adminsID,$realadminid)
    {

        $sql_output = $this->fetchAllKeyed("
            SELECT *
            FROM microsupport_support_chats WHERE (usersid='" . $userID ."' AND adminsid = '" . $adminsID . "') OR (usersid='" . $adminsID ."' AND adminsid = '" . $userID . "') ORDER BY datetime DESC", 'id');

		$array = array();
		foreach($sql_output AS $row => $output)
            {
		if($output['isbot'] == 1){
			$botinfo = $this->getbotinfo();
		$username = array('username' => '<font color="#669900">'.$botinfo['botusername'].'</font>');
		}else{
			if($output['usersid'] == $output['realadminid']){
		$username = $this->_Getuserinfo($output['usersid']);
		if($username['username']){
		$username['username'] = '<font color="#FF0000">'.$username['username'].'</font>';
		}else{
		$username['username'] = '<font color="#FF0000">Guest</font>';
		}
			}else{
		$username = $this->_Getuserinfo($output['usersid']);
		if($username['username']){
		$username['username'] = '<font color="#0000CC">'.$username['username'].'</font>';
		}else{
		$username['username'] = '<font color="#0000CC">Guest</font>';
		}
			}
		}
		$adminname = $this->_Getuserinfo($output['adminsid']);

				$array[] = array(
                'id' => $output['id'],
                'message' => $output['chat'],
                'datetime' => $output['datetime'],
                'adminname' => $adminname['username'],
                'username' => $username['username']
                );

			}

        return $array;
    }

    public function AdminlistallUserChatarchives($userid,$adminid,$fetchOptions)
    {

	if($fetchOptions['page'] == 0 || $fetchOptions['page'] == ''){
		$fetchOptions['offset'] = 0;
	}else{
		$fetchOptions['offset'] = $fetchOptions['perPage'];
	}

	$max = 'limit ' .($fetchOptions['page'] - 1) * $fetchOptions['perPage'] .',' .$fetchOptions['perPage'];

	$sql_output = $this->fetchAllKeyed('
            SELECT *
            FROM microsupport_support_archive
			WHERE adminsid = '.$adminid.' AND userid = '.$userid.'
			'.$max.'
        ', 'id');

		foreach($sql_output AS $row => $output)
            {
		$adminname = $this->_Getuserinfo($output['adminsid']);
		$username = $this->_Getuserinfo($output['userid']);
				$array[] = array(
                'id' => $output['id'],
                'cid' => $output['cid'],
                'adminsid' => $output['adminsid'],
                'adminname' => $adminname['username'],
                'userid' => $output['userid'],
                'username' => $username['username'],
                'chat' => $output['chat'],
                'datetime' => $output['datetime'],
                'itemcount' => $this->getCountUserChatarchives($output['userid'],$output['adminsid'])
                );

			}

        return $array;
    }

	public function AdminDeleteUserChatarchives($userid,$adminid)
	{
		$this->_getDb()->fetchRow("DELETE FROM microsupport_support_archive WHERE adminsid = ".$adminid." AND userid =  ".$userid);
	}

    public function getAttachmentByID($id, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

        $info = $this->_getDb()->fetchRow('
            SELECT *
            FROM microsupport_ticket_replies
            WHERE id = ?
        ', $id);

        return $info ? $info : false;
    }

    public function ajaxchat_checkfordownload(array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);
		$userid = $viewingUser['user_id'];

        $settings = $this->adminSettingsinfo(1);
	$downloadfolder = $settings['microsupport_upload_path'];

	$supportdls = $this->microsupport_supportdls_online($userid);
	$dlURL = '';

	$supportdls['dlid'] = $supportdls['dlid'] ? $supportdls['dlid'] : false;
		if($supportdls['dlid'] > 0){
	$hasdls = 1;
	$boardUrl = XenForo_Application::get('options')->boardUrl;
	    $dlURL = $boardUrl . '/mcsupport/downloads/' . $supportdls["dlfile"];
		}else{
	$hasdls = 0;
		}
		$array = array(
                'hasdls' => $hasdls,
                'dlURL' => $dlURL
                );

        return $array ? $array : false;
    }

	public function microsupport_supportdls_downloaded($userID)
	{
		return $this->_getDb()->fetchRow("UPDATE microsupport_support_chat_dl SET `active` = 0 WHERE uid='" . $userID ."'");
	}

	public function uploadFileInsertSQL($file,$adminId,$userid)
	{

		$this->_getDb()->fetchRow('INSERT INTO microsupport_support_chat_dl (uid, dlfile, downloaded, active) 
        VALUES('.$userid.',"'.$file.'", 0, 1)');
	}

	public function microsupport_ajaxbot_chat($userID,$adminsID,$chat_body)
	{

		$infos = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_chatbot_qanda 
			ORDER BY id ASC
        ');
		$i=1;
		foreach($infos AS $row => $info)
		{
		if(stristr($chat_body, $info['pattern'])){
			$this->microsupport_ajaxbot_addnew_chat($adminsID,$userID,$info['template'],1);
		}
		}
	}

	public function microsupport_teach_ajaxbot($chat_body)
	{

	$chat_body=str_replace("/teach",'',$chat_body);
	$pieces = explode(",", $chat_body);

	$template=str_replace(",","",$pieces[1]);
	$this->_getDb()->fetchRow('INSERT INTO microsupport_chatbot_qanda (pattern, template) 
        VALUES("'.trim($pieces[0]).'","'.addslashes($template).'")');
	}

	public function microsupport_ajaxbot_addnew_chat($userID,$adminsID,$chat_body,$isbot,$realadminid)
	{

		$this->_getDb()->fetchRow('INSERT INTO microsupport_support_chats (usersid, adminsid, chat, datetime,isbot,realadminid) 
        VALUES('.$userID.','.$adminsID.',"'.addslashes($chat_body).'",now(),'.$isbot.','.$realadminid.')');
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function microsupport_changebotname_ajaxbot($chat_body)
	{

	$chat_body=str_replace("/changebot",'',$chat_body);
	$pieces = explode(",", $chat_body);

	$template=str_replace(",","",$pieces[0]);
	$this->_getDb()->fetchRow("UPDATE microsupport_bot SET value = '".$template."' WHERE name = 'name'");
		return $this->_getDb()->fetchRow("UPDATE microsupport_botname SET `botusername` = '".$template."' WHERE id=1");
	}

	public function microsupport_activatebot_ajaxbot($chat_body)
	{

	$chat_body=str_replace("/activatebot",'',$chat_body);
	$pieces = explode(",", $chat_body);

	$template=str_replace(",","",$pieces[0]);

		return $this->_getDb()->fetchRow("UPDATE microsupport_botname SET `active` = '".$template."' WHERE id=1");
	}

	public function microsupport_unteach_ajaxbot($chat_body)
	{

	$chat_body=str_replace("/unteach",'',$chat_body);
	$pieces = explode(",", $chat_body);

		$this->_getDb()->fetchRow("DELETE FROM microsupport_chatbot_qanda WHERE pattern = '".trim($pieces[0])."'");

	}

	public function archivechat($userID,$adminsID,$newrealadminid)
	{
	$userID = $userID;
	$adminsID = $adminsID;
     $sql = $this->microsupport_admin_get_chat($userID,$adminsID);

	 foreach ($sql AS $row)
		{
		$userinfo = $this->_Getuserinfo($row['usersid']);
	    $id = $row["id"];
	    $user_name = $userinfo["username"];
	    $chat_body = $row["chat"];
	    $date_time = $row["datetime"];
	    //$chat_body = stripslashes($chat_body);
        //$chat_body = eregi_replace("&#39;", "'", $chat_body);
	if($userID == $row['usersid']){
		$color = '#006699';
	}else{
		$color = '#FF0000';
	}
        $body = '<b><font color="'.$color.'">' . $user_name . ': </font></b> 
	    <font color="#999999">' . $date_time . '</font>  
	    <font color="#000000"> ' . $chat_body . '</font>
        <br />';

		$chat_body = $userinfo["username"].' '.$date_time.' -- ' . $chat_body;

		$archiveinfo = $this->microsupport_checkarchiveBYID($id);
		if($archiveinfo["cid"] == $id){
		}else{
		$this->microsupport_admin_add_archive($id,$adminsID,$userID,addslashes($body),$date_time);
		}

    }
	$this->microsupport_admin_addnew_chat($userID,$adminsID,'Your Chats have been archived for later use, they have been deleted from the live chat.',$newrealadminid);


	}

    public function Statement($pattern)
    {

        $cat = $this->_getDb()->fetchRow('
            SELECT id FROM microsupport_templates WHERE bot=1 AND pattern LIKE "'.$pattern.'"
        ');

        return $cat ? $cat : false;
    }

    public function Statementdelete($id)
    {

        $cat = $this->_getDb()->fetchRow('
            DELETE FROM microsupport_templates WHERE bot=1 AND id=?
        ', $id);

        return $cat ? $cat : false;
    }

	public function microsupport_add_mapuser($UsersID,$ipaddress,$latitude,$longitude)
	{
        $info = $this->_getDb()->fetchRow('
            SELECT uid FROM microsupport_mapuser WHERE ipaddress="'.$ipaddress.'"
        ');
		if($info){
        return false;
		}else{
		$this->_getDb()->fetchRow("INSERT INTO microsupport_mapuser
                      SET uid=".$UsersID.",
                          ipaddress='".$ipaddress."',
                          latitude='".$latitude."',
                          longitude='".$longitude."'");
        return true;
		}
	}

    public function getmapusers()
    {
	$output = array();

	$Importants = $this->_getDb()->fetchAll('
            SELECT *
            FROM microsupport_mapuser
        ');

		foreach($Importants AS $row => $Important)
		{
			$output[] = array(
                'uid' => $Important['uid'],
                'ipaddress' => $Important['ipaddress'],
                'latitude' => $Important['latitude'],
                'longitude' => $Important['longitude'],
                );
		}

        return $output;
    }

	public function Crondeleteoldchats()
	{
	$this->_getDb()->fetchRow("DELETE FROM microsupport_support_chats");
	}

public function getLatestNews($perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

  $array = array();
  
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_news 
		WHERE active = 1
		GROUP BY id  
		ORDER BY dateadded DESC 
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {
		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('HtmlEmail'));
		$output['message'] = new XenForo_BbCode_TextWrapper($output['message'], $bbCodeParserHtml);

				$array[] = array(
                'id' => $output['id'],
                'newstitle' => $output['newstitle'],
                'message' => $this->LimitTextOutput(strip_tags($output['message']),$limit = 80),
                'dateadded' => $output['dateadded'],
                'active' => $output['active']
                );
		  

            }

  return $array;
}

public function techgetLatestNews($perpage,$page, array $viewingUser = null)
	{
		$this->standardizeViewingUserReference($viewingUser);

  $array = array();
  
		if($page == '' || $page == 0){
			$page = 1;
		}
		$sql_output = $this->_getDb()->fetchAll('SELECT * FROM microsupport_news
		GROUP BY id  
		ORDER BY dateadded DESC 
		LIMIT ' .($page - 1) * $perpage .','.$perpage);

		foreach($sql_output AS $row => $output)
            {
		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('HtmlEmail'));
		$output['message'] = new XenForo_BbCode_TextWrapper($output['message'], $bbCodeParserHtml);

				$array[] = array(
                'id' => $output['id'],
                'newstitle' => $output['newstitle'],
                'message' => $this->LimitTextOutput(strip_tags($output['message']),$limit = 80),
                'dateadded' => $output['dateadded'],
                'active' => $output['active']
                );
		  

            }

  return $array;
}

    public function techgetCountLatestNews()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_news`"));

		return $total;
    }

    public function getCountLatestNews()
    {
		$total = count($this->_getDb()->fetchAll("SELECT * FROM `microsupport_news`
		WHERE active = 1"));

		return $total;
    }

    public function counttectuserslimit()
    {

			$testdepartments = $this->getdepartments();

			$total = 0;
			foreach($testdepartments AS $row => $testdepartment)
		{
			$techusers = explode(",", $testdepartment['emails']);
			$arrlength=count($techusers);
			$total += $arrlength;
			//print_r($techusers);
		}

			if($total > 5){
				return false;
			}else{
				return true;
			}

    }

	public function UpdateNews($input)
	{
		$this->_getDb()->fetchRow('UPDATE microsupport_news
                                    SET newstitle = "'.$input['title'].'",
                                        message = "'.$input['message'].'",
                                        active = '.$input['status'].'
										WHERE id='.$input['id']);
			$lastInsertId = $this->_getDb()->lastInsertId();						 
			return $lastInsertId;
	}

	public function Crondoemailtoticket()
	{
			$departments = $this->getdepartments();
        $settings = $this->adminSettingsinfo(1);

              foreach($departments AS $department)
              {
				  
	if(!empty($department["emails"]))
          {
              $toemails = explode(",", $department['emails']);
              foreach($toemails AS $toemail)
              {
				  if(XenForo_Application::get('options')->microsupport_user == $toemail){

					  $did = $department["id"];
					  	$host = XenForo_Application::get('options')->microsupport_host;
						$port = XenForo_Application::get('options')->microsupport_port;
						$user = XenForo_Application::get('options')->microsupport_user;
						$pass = XenForo_Application::get('options')->microsupport_pass;
						$connection = $this->pop3_login($host,$port,$user,$pass);
						$messages = $this->pop3_list($connection);
					if($messages){
						foreach ($messages as $message){
						$getmessage = $this->retrieve_message($connection,$message['uid']);
						$output['subject'] = $getmessage['subject'];
						$output['fromuser'] = $getmessage['from'];
						$output['touser'] = $getmessage['toaddress'];
						$output['message'] = $getmessage['body'];
						$output['bodytext'] = XenForo_Helper_String::autoLinkBbCode($output['message']);
    					$output['updated'] = time();
   		 				$output['status'] = 1;
    					$output['needaction'] = 1;
    					$output['priority'] = $this->Getpriorityoption();
    					$output['newreply'] = 0;
    					$output['newticket'] = 1;
						$tid = '';
				if (preg_match_all('/TID\d*/i', $getmessage['subject'], $matches))
 				{
           	$tid = str_replace ("TID", '', $matches[0][0]);
 				}

$userinfo = $this->_getDb()->fetchRow("SELECT * FROM xf_user WHERE email='".$output['fromuser']."'");
	if($userinfo){
		$uid = $userinfo['user_id'];
	}else{
		$uid = 0;
	}

	$techinfo = $this->getRecordByEmail('xf_user', $toemail, 'email');

			$getticket = $this->GetTicket($tid);
		$ticket = $getticket;
    	$owner = $ticket['userid'];

		if($tid){
		if($uid == $ticket['userid'] || $techinfo['user_id']){
		$this->_getDb()->fetchRow('INSERT INTO microsupport_ticket_replies
                                 SET bodytext="'.strip_tags(addslashes($output['bodytext'])).'",
                                     ticketid='.$tid.',
                                     attachment="",
                                     userid='.$uid.',
                                     created='.$output['updated'].'');
						  $lastInsertId = $tid;
	$this->AlertUserTicketHolder($tid, $owner);
		}
			}else{
									 
		$this->_getDb()->fetchRow("INSERT INTO microsupport_tickets
                      SET userid=".$uid.",
                          departmentid=".$did.",
                          title='".$output['subject']."',
                          bodytext='".strip_tags(addslashes($output['bodytext']))."',
                          created=".$output['updated'].",
                          updated=".$output['updated'].",
                          needaction=".$output['needaction'].",
                          priority=".$output['priority'].",
                          status=".$output['status'].",
                          newreply=".$output['newreply'].",
                          newticket=".$output['newticket'].",
                          guestemail='".$output['fromuser']."'");
						  $lastInsertId = $this->_getDb()->lastInsertId();
			}

			$adepartments = $this->getdepartments();
              foreach($adepartments AS $adepartment)
              {
				  
	if(!empty($adepartment["emails"]))
          {
              $atoemails = explode(",", $adepartment['emails']);
              foreach($atoemails AS $atoemail)
              {
	$atechinfo = $this->getRecordByEmail('xf_user', $atoemail, 'email');

	$this->AlertDepartmentTecs($lastInsertId, $atechinfo['user_id'], $uid, 0);
			  }
		  }
			  }


			$this->pop3_dele($connection,$message['uid']);
					}
imap_expunge($connection);

				}
				  }
			  }
		  }
			  }
	}

	public function retrieve_message($mbox, $messageid)
{
   $message = array();
    
   $header = imap_header($mbox, $messageid);
   $structure = imap_fetchstructure($mbox, $messageid);

   $message['subject'] = $header->subject;
   $message['fromaddress'] =   $header->fromaddress;
   $fromaddress = $header->from;
   $message['from'] = $fromaddress[0]->mailbox.'@'.$fromaddress[0]->host;
   $message['toaddress'] =   $header->toaddress;
   $message['date'] =   $header->date;

   //print_r($clientip);

  if ($this->check_type($structure))
  {
   $message['body'] = imap_fetchbody($mbox,$messageid,"1"); ## GET THE BODY OF MULTI-PART MESSAGE
   if(!$message['body']) {$message['body'] = '[NO TEXT ENTERED INTO THE MESSAGE]\n\n';}
  }
  else
  {
   $message['body'] = imap_body($mbox, $messageid);
   if(!$message['body']) {$message['body'] = '[NO TEXT ENTERED INTO THE MESSAGE]\n\n';}
  }
   
  return $message;
}

	public function check_type($structure) ## CHECK THE TYPE
{
  if($structure->type == 1) 
    {
     return(true); ## YES THIS IS A MULTI-PART MESSAGE
    }
 else
    {
     return(false); ## NO THIS IS NOT A MULTI-PART MESSAGE
    }
}

	public function pop3_login($host,$port,$user,$pass,$folder="INBOX",$ssl=false)
	{
		$ssl=($ssl==false)?"/novalidate-cert":""; 
    return (imap_open("{"."$host:$port/pop3$ssl"."}$folder",$user,$pass)); 
	} 

	public function pop3_readmessage($connection,$uid)        
	{ 
    if( $connection ) { 
    
     //Check no.of.msgs 
     $num = imap_num_msg($connection); 

     //if there is a message in your inbox 
     if( $num >0 ) { 
          //read that mail recently arrived 
          return imap_qprint(imap_body($connection, $num)); 
     } 

     //close the stream 
     imap_close($connection); 
	} 
	} 

	public function pop3_list($connection,$message="") 
	{ 
	$result = '';
    if ($message) 
    { 
        $range=$message; 
    } else { 
        $MC = imap_check($connection); 
        $range = "1:".$MC->Nmsgs; 
    } 
    $response = imap_fetch_overview($connection,$range); 
    foreach ($response as $msg) $result[$msg->msgno]=(array)$msg;
	return $result ? $result : false; 
	} 
	public function pop3_dele($connection,$message) 
	{ 
    return(imap_delete($connection,$message)); 
	} 


}
