<?php

class MicroSupport_WidgetRenderer_LatestDownloads extends WidgetFramework_WidgetRenderer {
	protected function _getConfiguration() {
		return array(
			'name' => '(MicroSupport) Latest Downloads',
		);
	}

	protected function _getOptionsTemplate() {
		return false;
	}

	protected function _getRenderTemplate(array $widget, $positionCode, array $params) {
		return 'microsupport_widget_latestdownloads_sidebar';
	}

	protected function _render(array $widget, $positionCode, array $params, XenForo_Template_Abstract $template) {

				$core = WidgetFramework_Core::getInstance();

				/* @var $threadModel XenForo_Model_Thread */
				$model = $core->getModelFromCache('MicroSupport_Model_MicroSupport');
        	$settings = $model->adminSettingsinfo(1);
        
		$latestdownloads = $model->getLatestDownloads($settings);

		$template->setParam('latestdownloads', $latestdownloads);

		return $template->render();
	}

}