<?php

class MicroSupport_WidgetRenderer_LatestQuestions extends WidgetFramework_WidgetRenderer {
	protected function _getConfiguration() {
		return array(
			'name' => '(MicroSupport) Latest Questions',
		);
	}

	protected function _getOptionsTemplate() {
		return false;
	}

	protected function _getRenderTemplate(array $widget, $positionCode, array $params) {
		return 'microsupport_widget_latestquestions_sidebar';
	}

	protected function _render(array $widget, $positionCode, array $params, XenForo_Template_Abstract $template) {

				$core = WidgetFramework_Core::getInstance();

				/* @var $threadModel XenForo_Model_Thread */
				$model = $core->getModelFromCache('MicroSupport_Model_MicroSupport');
        	$settings = $model->adminSettingsinfo(1);
        
		$latests = $model->getLatest($settings);

		$template->setParam('latests', $latests);

		return $template->render();
	}

}