<?php

class MicroSupport_WidgetRenderer_Livesupport extends WidgetFramework_WidgetRenderer {
	protected function _getConfiguration() {
		return array(
			'name' => '(MicroSupport) Live Support',
		);
	}

	protected function _getOptionsTemplate() {
		return false;
	}

	protected function _getRenderTemplate(array $widget, $positionCode, array $params) {
		return 'microsupport_widget_livechat_sidebar';
	}

	protected function _render(array $widget, $positionCode, array $params, XenForo_Template_Abstract $template) {

				$core = WidgetFramework_Core::getInstance();

				/* @var $threadModel XenForo_Model_Thread */
				$model = $core->getModelFromCache('MicroSupport_Model_MicroSupport');
        	$settings = $model->adminSettingsinfo(1);
        
			$adminsonline = $model->microsupport_supportusers_online();
			$botinfo = $model->getbotinfo();

		$template->setParam('adminsonline', $adminsonline);
		$template->setParam('botinfo', $botinfo);

		return $template->render();
	}

}