<?php

$startTime = microtime(true);
$fileDir = dirname(__FILE__);

require($fileDir . '/library/XenForo/Autoloader.php');
XenForo_Autoloader::getInstance()->setupAutoloader($fileDir . '/library');

XenForo_Application::initialize($fileDir . '/library', $fileDir);
XenForo_Application::set('page_start_time', $startTime);

$response = new Zend_Controller_Response_Http();

$deps = new XenForo_Dependencies_Public();
$deps->preLoadData();
XenForo_Session::startPublicSession(new Zend_Controller_Request_Http);

$model = XenForo_Model::create('MicroSupport_Model_MicroSupport');
global $model;
        $settings = $model->adminSettingsinfo(1);

	if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = '';
}
	if (empty($_REQUEST['requester']))
{
	$_REQUEST['requester'] = '';
}

if ($_REQUEST['do'] == "chatsettings") {

   $livesupportwelcometext = str_replace("<br>", "", $settings['microsupport_live_welcometext_text']);
   $livesupportlogintext = str_replace("<br>", "", $settings['microsupport_live_logintext_text']);
   $livesupportimagesize = $settings['microsupport_live_image_size'];
   $livesupportwelcometextcolour = $settings['microsupport_live_welcometext_colour'];
   $livesupportonlinetext = $settings['microsupport_live_onlinetext_text'];
   $backgrounda = $settings['microsupport_live_background_swf'];
   $livesupportfontcolor = $settings['microsupport_live_fontcolor'];
	$xml_output = "<?xml version =\"1.0\"?>";
	$xml_output = "<xml>\n";

		$xml_output .= "<ConfigureItems>\n";

		$xml_output .= "<welcometext>" . $livesupportwelcometext . "</welcometext>\n";

		$xml_output .= "<logintext>" . $livesupportlogintext . "</logintext>\n";

		$xml_output .= "<imagesize>" . $livesupportimagesize . "</imagesize>\n";

		$xml_output .= "<welcomecolour>" . $livesupportwelcometextcolour . "</welcomecolour>\n";

		$xml_output .= "<usersonlinetext>" . $livesupportonlinetext . "</usersonlinetext>\n";

		$xml_output .= "<fontcolor>" . $livesupportfontcolor . "</fontcolor>\n";

		$xml_output .= "<backgroundimage>mcsupport/bg/" . $backgrounda . "</backgroundimage>\n";

		$xml_output .= "</ConfigureItems>\n";

	$xml_output.= "</xml>";

	echo $xml_output;
}

if ($_REQUEST['requester'] == "livesupportsettings") {

   $livesupportwelcometext = str_replace("<br>", "", $settings['microsupport_live_welcometext_text']);
   $livesupportlogintext = str_replace("<br>", "", $settings['microsupport_live_logintext_text']);
   $livesupportimagesize = $settings['microsupport_live_image_size'];
   $livesupportwelcometextcolour = $settings['microsupport_live_welcometext_colour'];
   $livesupportonlinetext = $settings['microsupport_live_onlinetext_text'];
   $backgrounda = $settings['microsupport_live_background_swf'];
   $livesupportfontcolor = $settings['microsupport_live_fontcolor'];

	$xml_output = "<?xml version =\"1.0\"?>\n";
	$xml_output = "<XML>\n";

		$xml_output .= "\t<ConfigureItems>\n";

		$xml_output .= "\t\t<welcometext>" . $livesupportwelcometext . "</welcometext>\n";

		$xml_output .= "\t\t<logintext>" . $livesupportlogintext . "</logintext>\n";

		$xml_output .= "\t\t<imagesize>" . $livesupportimagesize . "</imagesize>\n";

		$xml_output .= "\t\t<welcomecolour>" . $livesupportwelcometextcolour . "</welcomecolour>\n";

		$xml_output .= "\t\t<usersonlinetext>" . $livesupportonlinetext . "</usersonlinetext>\n";

		$xml_output .= "\t\t<fontcolor>" . $livesupportfontcolor . "</fontcolor>\n";

		$xml_output .= "\t\t<backgroundimage>mcsupport/bg/" . $backgrounda . "</backgroundimage>\n";

		$xml_output .= "\t</ConfigureItems>\n";

	$xml_output.= "</XML>";

	echo $xml_output;

}

if ($_REQUEST['requester'] == "login") {

$username = $_REQUEST["username"];
$password = $_REQUEST["userpass"];
   
		$userModel = XenForo_Model::create('XenForo_Model_User');

		$query = $userModel->validateAuthentication($username, $password, $error);
 
   if(!$query){

	$success = 0;
	$isadmin = 0;
	$login_error = "Not a member!";
		$userid = '';
		$fname = '';
		$email = '';

}else{
		$visitor = $userModel->getUserById($query);

		$userid = $visitor["user_id"];
		$fname = $visitor["username"];
		$usergroupID = $visitor["user_group_id"];
		$email = $visitor["email"];
		$success = 1;

		$timeout = time()+3600;
		$supportusertimeout = time()+3600;

        $timout_sql = $model->microsupport_users_online($userid);

   if($timout_sql['userid'] == ""){
	   $model->microsupport_insert_users_online($userid,$fname,$usergroupID,$email,$timeout);
	   
	   //$model->microsupport_delete_users_online($userid);
	   
		}

	$admincpaccess = $settings['microsupport_admincp_access'];
	$admincpgroup = explode(',', $admincpaccess);
	//$allusergroups = $visitor["user_group_id"].','.$visitor["secondary_group_ids"];
	$allusergroups = explode(',', $visitor["user_group_id"].','.$visitor["secondary_group_ids"]);
	$isadmin = 0;
	foreach ($allusergroups AS $allusergroup)
		{

		if (in_array($allusergroup, $admincpgroup)){
	$isadmin = 1;
	}
	$login_error = "";
		}

}

$output = 'success=' . $success . 
'&userid=' . $userid . 
'&username=' . $fname . 
'&isadmin=' . $isadmin . 
'&email=' . $email . 
'&login_error=' . $login_error;

	echo $output;

}

if ($_REQUEST['requester'] == "supportadminsonlinestatus") {

	   $adminsonline = $model->microsupport_supportusers_online();

    $output = 'supportonline=' . $adminsonline['supportuserstatus'];

	echo $output;

}

if ($_REQUEST['requester'] == "adminlogout") {

	$adminID = $_REQUEST["adminID"];

	$model->microsupport_adminlogout_online($adminID);

    $output = 'done=done';

	echo $output;

}

if ($_REQUEST['requester'] == "adminlogin") {

	$adminID = $_REQUEST["adminID"];

		$supportusertimeout = time()+120;

	$model->microsupport_adminlogin_online($adminID,$supportusertimeout);

    $output = 'done=done';

	echo $output;

}

if ($_REQUEST['requester'] == "dochat") {


	$adminID = $_REQUEST["adminID"];

	$usersUID = $_REQUEST["usersUID"];

		$supportusertimeout = time()+120;

	$model->microsupport_dochat_online($adminID,$usersUID,$supportusertimeout);

    $output = 'success=1';

	echo $output;

}

if ($_REQUEST['requester'] == "dochatlogout") {

	$usersUID = $_REQUEST["usersUID"];

		$supportusertimeout = time()+120;

	$model->microsupport_dochatlogout_online($usersUID);

    $output = 'success=1';

	echo $output;

}

if ($_REQUEST['requester'] == "onoffinchatimage") {

   
	$xml_output = "<?xml version =\"1.0\"?>\n";
	$xml_output = "<statusimages>\n";

		$xml_output .= "\t<statusimage>\n";
		$xml_output .= "\t\t<statusa>online</statusa>\n";
		$xml_output .= "\t\t<imageurl>tech_support_icon_online.png</imageurl>\n";
		$xml_output .= "\t</statusimage>\n";
		$xml_output .= "\t<statusimage>\n";
		$xml_output .= "\t\t<statusa>offline</statusa>\n";
		$xml_output .= "\t\t<imageurl>tech_support_icon_offline.png</imageurl>\n";
		$xml_output .= "\t</statusimage>\n";
		$xml_output .= "\t<statusimage>\n";
		$xml_output .= "\t\t<statusa>inchat</statusa>\n";
		$xml_output .= "\t\t<imageurl>tech_support_icon_inchat.png</imageurl>\n";
		$xml_output .= "\t</statusimage>\n";
 
	$xml_output.= "</statusimages>";

	echo $xml_output;

}

if ($_REQUEST['requester'] == "supportadminlistlist") {

	$departments = $model->microsupport_supportadminlistlist_online();

	$output = '';
	$output .= '<data>';

	foreach ($departments AS $department)
		{
			$id = $department['supportuserid'];

			$userinfo = $model->_Getuserinfo($id);

	$output .= '<item>';
	$output .= '<supportuserid>'.$department['supportuserid'].'</supportuserid>';
	$output .= '<supportadminname>'.$userinfo['username'].'</supportadminname>';
	$output .= '</item>';

	}
	$output .= '</data>';

	echo $output;

}

if ($_REQUEST['requester'] == "background_list") {

   
	$xml_output = "<?xml version =\"1.0\"?>\n";
	$xml_output = "<bglists>\n";

	$where = 'WHERE active = 1';

	//$limit = 'LIMIT ' .($page - 1) * $perpage .','.$perpage;
  
		//if($page == '' || $page == 0){
		//	$page = 1;
		//}
	$limit = '';

     $sql = $model->microsupport_admin_get_bgs($where, $limit);
	 
	 foreach ($sql AS $row)
		{
		$xml_output .= "\t<bglist>\n";
		$xml_output .= "\t\t<bgid>".$row['id']."</bgid>\n";
		$xml_output .= "\t\t<bgname>".$row['title']."</bgname>\n";
		$xml_output .= "\t\t<bgurl>mcsupport/bg/".$row['swf']."</bgurl>\n";
		$xml_output .= "\t</bglist>\n";
		}
 
	$xml_output.= "</bglists>";

	echo $xml_output;

}

if ($_REQUEST['requester'] == "usersonline") {

   $timerunout =time()+120;
   
XenForo_Session::startPublicSession();
$xfUser = XenForo_Visitor::getInstance();
$xfUser_Id = $xfUser->getUserId();

   $usergroupid = $xfUser['user_group_id'];
   
	$admincpaccess = $settings['microsupport_admincp_access'];
	$admincpgroup = explode(',', $admincpaccess);
	//$allusergroups = $visitor["user_group_id"].','.$visitor["secondary_group_ids"];
	$allusergroups = explode(',', $xfUser["user_group_id"].','.$xfUser["secondary_group_ids"]);
$usersonline_font_color = '#999900';
	foreach ($allusergroups AS $allusergroup)
		{

		if (in_array($allusergroup, $admincpgroup)){
$usersonline_font_color = '#FF0000';
	}
		}

$usersonline_font_size = '-1';

$overSkin_color = '#FF0033';
$downSkin_color = '#FFFF00';
$upSkin_color = '#FF11FF';


	$xml_output = "<?xml version =\"1.0\"?>\n";
	$xml_output .= "<onlineuserlists>\n";

		$xml_output .= "\t\t<overSkin_color>" . $overSkin_color . "</overSkin_color>\n";
		$xml_output .= "\t\t<downSkin_color>" . $downSkin_color . "</downSkin_color>\n";
		$xml_output .= "\t\t<upSkin_color>" . $upSkin_color . "</upSkin_color>\n";

	$usersonline = "";
    $sql = $model->microsupport_getusers_online(); 

	foreach ($sql AS $row)
		{
	    $user_id = $row["userid"];
	    $user_name1 = $row["username"];
	    $time = $row["timeout"];
		$userinfo_sql = $model->_Getuserinfo($user_id);
		$xml_output .= "\t<onlineuserlist>\n";
		$xml_output .= "\t\t<onlineun>" . $user_name1 . "</onlineun>\n";
		$xml_output .= "\t\t<onlineuid>" . $user_id . "</onlineuid>\n";
		$xml_output .= "\t\t<avatarsurl></avatarsurl>\n";
		$xml_output .= "\t\t<onlineemail>" . $userinfo_sql['email'] . "</onlineemail>\n";
		$xml_output .= "\t</onlineuserlist>\n";

    }


	$xml_output.= "</onlineuserlists>";

	echo $xml_output;

}

if ($_REQUEST['requester'] == "dolivelogout") {

	$usersUID = $_REQUEST['usersUID'];

	$model->microsupport_dolivelogout_online($usersUID);

    $output = 'success=1';

	echo $output;

}

if ($_REQUEST['requester'] == "livesupportsavefile") {
// Set local PHP vars from the POST vars sent from flash
$filename = $_FILES['Filedata']['name'];
$filetmpname = $_FILES['Filedata']['tmp_name'];
$fileType = $_FILES["Filedata"]["type"];
$fileSizeMB = ($_FILES["Filedata"]["size"] / 1024 / 1000);

    //$adminid = $vbulletin->input->clean_gpc('g', 'adminid', TYPE_STR);

	$UsersID = $_REQUEST['UsersID'];
	$userid = $_REQUEST['userid'];

$downloaddate = date('d-m-Y');
	$downloadfolder = $settings['microsupport_upload_path'];
    $productfilename = "";
    if(!empty($_FILES["Filedata"]["name"]))
    {
        if($_FILES["Filedata"]["error"] == UPLOAD_ERR_OK)
        {
           @unlink($downloadfolder . $_FILES["Filedata"]["name"]);
           $extension = $model->findext($_FILES["Filedata"]["name"]);
           $filename = $model->stripext($_FILES["Filedata"]["name"]);
           $time = time();
           $productfilename = 'admin_'.$filename.'_'.md5(time() + rand()).'.'.$extension;
           rename($_FILES["Filedata"]["tmp_name"], $downloadfolder . $productfilename);

	$model->microsupport_livesupportsavefile_online($UsersID,$productfilename);
    
   // $newid = $db->insert_id();
		}
    }
}

if ($_REQUEST['requester'] == "checkfor_dls") {
   
	$DLuserID = $_REQUEST['DLuserID'];
	$downloadfolder = $settings['microsupport_upload_path'];

	$supportdls = $model->microsupport_supportdls_online($DLuserID);
	$dlURL = '';

		if($supportdls['dlid'] > 0){
	$hasdls = 1;
	$boardUrl = XenForo_Application::get('options')->boardUrl;
	    $dlURL = $boardUrl . '/mcsupport/downloads/' . $supportdls["dlfile"];
		}else{
	$hasdls = 0;
		}

    echo "dlURL=$dlURL&Hasdls=$hasdls";

}

if ($_REQUEST['requester'] == "filedownloaded_dls") {
   
	$userid = $_REQUEST['userid'];
   
	$model->microsupport_supportdls_downloaded($userid);

}

if ($_REQUEST['requester'] == "request_replys") {
   
XenForo_Session::startPublicSession();
$xfUser = XenForo_Visitor::getInstance();
$userID = $xfUser->getUserId();

	$totalsubproducts = $model->microsupport_request_replys_online($userID);

    echo "returnNumReplys=$totalsubproducts";

}

if ($_REQUEST['requester'] == "request_adviserreplys") {
   
	$userID = $_REQUEST['userid'];

	$totalad = $model->microsupport_request_adviserreplys_online($userID);

    echo "returnadviserNum=$totalad";

}

if ($_REQUEST['requester'] == "guestlogin") {

$username = $_REQUEST["username"];
$userid = $_REQUEST["userid"];
$gemail = $_REQUEST["gemail"];
   
		$userid = $userid;
		$fname = $username;
		$usergroupID = 0;
		$email = $gemail;
		$success = 1;

		$timeout = time()+3600;
		$supportusertimeout = time()+3600;

	$timout_sql = $model->microsupport_users_online($userid);

   if($timout_sql['userid'] == ""){
	   $model->microsupport_insert_users_online($userid,$fname,$usergroupID,$email,$timeout);
	   $model->microsupport_delete_users_online($userid);

}
$login_error = '';
	$isadmin = 0;


$output = 'success=' . $success . 
'&userid=' . $userid . 
'&username=' . $fname . 
'&isadmin=' . $isadmin . 
'&email=' . $email . 
'&login_error=' . $login_error;

	echo $output;

}

if ($_REQUEST['requester'] == "admincpuser_list") {

	$output = '';
	$output .= '<data>';
	$tickets = $model->microsupport_admincpuser_list_online();

	foreach ($tickets AS $ticket)
		{
	$output .= '<item>';
	$output .= '<user_id>'.$ticket['user_id'].'</user_id>';
	$output .= '<user_name>'.$ticket['username'].'</user_name>';
	$output .= '</item>';

	}
	$output .= '</data>';

	echo $output;

}

if ($_REQUEST['requester'] == "admindologout") {

	$usersUID = $_REQUEST["usersUID"];

	$model->microsupport_dolivelogout_online($usersUID);

    $output = 'success=1';

	echo $output;

}

if ($_REQUEST['requester'] == "isloggedin") {

	$usersUID = $_REQUEST["usersUID"];

	$userinfo = $model->microsupport_users_online($usersUID);
	if($userinfo['userid'] > 0){
    $output = 'isloggedin=1';
	}else{
    $output = 'isloggedin=0';
	}

	echo $output;

}

if ($_REQUEST['requester'] == "admin_new_chat") {

$userID = $_REQUEST["usersID"];
$adminsID = $_REQUEST["adminsID"];
$chat_body = $_REQUEST["chat_body"];

	$latest_id = $model->microsupport_admin_addnew_chat($adminsID,$userID,$chat_body);

     $body = "";
	$sql = $model->microsupport_admin_get_chat($userID,$adminsID);
	 
	 foreach ($sql AS $row)
		{
		$userinfo = $model->_Getuserinfo($row['usersid']);
              $id = $row["id"];
              $user_name = $userinfo["username"];
              $chat_body = $row["chat"];
              $date_time = $row["datetime"];
	     //$chat_body = stripslashes($chat_body);
         //$chat_body = eregi_replace("&#39;", "'", $chat_body);
	if($userID == $row['usersid']){
		$color = '#006699';
	}else{
		$color = '#FF0000';
	}
	     $body .= '<b><font color="'.$color.'">' . $user_name . ': </font></b>
	     <font color="#999999">' . $date_time . '</font>  
	     <font color="#000000"> <![CDATA[' . $chat_body . ']]></font>
	     <br />';

     }
     
     echo "stored_id=$latest_id&statusline=poopoo&returnBody=$body";

}

if ($_REQUEST['requester'] == "checkchatcall_request") {

	$adminsID = $_REQUEST['adminsID'];

	$row = $model->microsupport_checkchatcall_request_chat($adminsID);

		if($row['usersUID'] > 0){
  
$usersid = $row['usersUID'];
    $output = 'checkchatcall=1&supportuseridrequester='.$usersid;
		}else{

    $output = 'checkchatcall=0';
		}

	echo $output;

}

if ($_REQUEST['requester'] == "new_chat") {

	$userID = $_REQUEST['usersID'];
	$adminsID = $_REQUEST['adminsID'];
	$chat_body = $_REQUEST['chat_body'];

	$latest_id = $model->microsupport_user_addnew_chat($userID,$adminsID,$chat_body);

     $body = "";
     $sql = $model->microsupport_admin_get_chat($userID,$adminsID);
	 
	 foreach ($sql AS $row)
		{
		$userinfo = $model->_Getuserinfo($row['usersid']);
              $id = $row["id"];
              $user_name = $userinfo["username"];
              $chat_body = $row["chat"];
              $date_time = $row["datetime"];
	     //$chat_body = stripslashes($chat_body);
         //$chat_body = eregi_replace("&#39;", "'", $chat_body);
	if($userID == $row['usersid']){
		$color = '#006699';
	}else{
		$color = '#FF0000';
	}
	     $body .= '<b><font color="'.$color.'">' . $user_name . ': </font></b>
	     <font color="#999999">' . $date_time . '</font>  
	     <font color="#000000"> '.$chat_body.'</font>
	     <br />';

     }
     
	$xml_output = "<?xml version =\"1.0\"?>\n";
	$xml_output = "<XML>\n";

		$xml_output .= "\t<UserChat>\n";

		$xml_output .= "\t\t<returnBody><![CDATA[" . $body . "]]></returnBody>\n";

		$xml_output .= "\t\t<stored_id>" . $latest_id . "</stored_id>\n";

		$xml_output .= "\t\t<statusline></statusline>\n";

		$xml_output .= "\t</UserChat>\n";

	$xml_output.= "</XML>";

	//echo $xml_output;

		  print "stored_id=$latest_id&statusline=poopoo&returnBody=$body";

}

if ($_REQUEST['requester'] == "chat_check") {

	$userID = $_REQUEST['userID'];
	$adminsID = $_REQUEST['adminsID'];
	$stored_id = $_REQUEST['stored_id'];

	$status_line = "not_new";

     $row = $model->microsupport_checklastid($userID,$adminsID);
	 
	    $latest_id = $row["id"];

    if ($latest_id > $stored_id) {
         
		 $status_line = "is_new";
 	     $body = "";
     $sql = $model->microsupport_admin_get_chat($userID,$adminsID);
	 
	 foreach ($sql AS $row)
		{
		$userinfo = $model->_Getuserinfo($row['usersid']);
              $id = $row["id"];
              $user_name = $userinfo["username"];
              $chat_body = $row["chat"];
              $date_time = $row["datetime"];
              //$chat_body = stripslashes($chat_body);
              //$chat_body = eregi_replace("&#39;", "'", $chat_body);
if($userID == $row['usersid']){
		$color = '#006699';
	}else{
		$color = '#FF0000';
	}
              $body .= '<b><font color="'.$color.'">' . $user_name . ': </font></b> 
              <font color="#999999">' . $date_time . '</font>  
              <font color="#000000"> '.$chat_body.'</font>
              <br />';

          }

	$xml_output = "<?xml version =\"1.0\"?>\n";
	$xml_output = "<XML>\n";

		$xml_output .= "\t<UserChat>\n";

		$xml_output .= "\t\t<returnBody><![CDATA[" . $body . "]]></returnBody>\n";

		$xml_output .= "\t\t<stored_id>" . $latest_id . "</stored_id>\n";

		$xml_output .= "\t\t<statusline>" . $status_line . "</statusline>\n";

		$xml_output .= "\t</UserChat>\n";

	$xml_output.= "</XML>";

	echo $xml_output;

		  //echo "stored_id=$latest_id&statusline=$status_line&returnBody=$body";
	} 
}

if ($_REQUEST['requester'] == "loadchat") {
   
	$userID = $_REQUEST['userID'];
	$adminsID = $_REQUEST['adminsID'];

    $status_line = "initial load";
    $body = "";
	if(empty($userID) || empty($adminsID)){
		$row["id"] = 0;
	}else{
     $sql = $model->microsupport_admin_get_chat($userID,$adminsID);

	 foreach ($sql AS $row)
		{
		$userinfo = $model->_Getuserinfo($row['usersid']);
	    $id = $row["id"];
	    $user_name = $userinfo["username"];
	    $chat_body = $row["chat"];
	    $date_time = $row["datetime"];
	    //$chat_body = stripslashes($chat_body);
        //$chat_body = eregi_replace("&#39;", "'", $chat_body);
	if($userID == $row['usersid']){
		$color = '#006699';
	}else{
		$color = '#FF0000';
	}
        $body .= '<b><font color="'.$color.'">' . $user_name . ': </font></b> 
	    <font color="#999999">' . $date_time . '</font>  
	    <font color="#000000"> ' . $chat_body . '</font>
        <br />';

    }

     $row = $model->microsupport_checklastid($userID,$adminsID);
	}
	 
	    $stored_id = $row["id"];

	$xml_output = "<?xml version =\"1.0\"?>\n";
	$xml_output = "<XML>\n";

		$xml_output .= "\t<UserChat>\n";

		$xml_output .= "\t\t<returnBody><![CDATA[" . $body . "]]></returnBody>\n";

		$xml_output .= "\t\t<stored_id>" . $stored_id . "</stored_id>\n";

		$xml_output .= "\t\t<statusline>" . $status_line . "</statusline>\n";

		$xml_output .= "\t</UserChat>\n";

	$xml_output.= "</XML>";

	echo $xml_output;

    //echo "stored_id=$stored_id&statusline=$status_line&returnBody=$body";

}

if ($_REQUEST['requester'] == "admin_archivechat") {

	$userID = $_REQUEST['usersUID'];
	$adminsID = $_REQUEST['adminsID'];
     $sql = $model->microsupport_admin_get_chat($userID,$adminsID);

	 foreach ($sql AS $row)
		{
		$userinfo = $model->_Getuserinfo($row['usersid']);
	    $id = $row["id"];
	    $user_name = $userinfo["username"];
	    $chat_body = $row["chat"];
	    $date_time = $row["datetime"];
	    //$chat_body = stripslashes($chat_body);
        //$chat_body = eregi_replace("&#39;", "'", $chat_body);
	if($userID == $row['usersid']){
		$color = '#006699';
	}else{
		$color = '#FF0000';
	}
        $body = '<b><font color="'.$color.'">' . $user_name . ': </font></b> 
	    <font color="#999999">' . $date_time . '</font>  
	    <font color="#000000"> ' . $chat_body . '</font>
        <br />';

		$chat_body = $userinfo["username"].' '.$date_time.' -- ' . $chat_body;

		$archiveinfo = $model->microsupport_checkarchiveBYID($id);
		if($archiveinfo["cid"] == $id){
		}else{
		$model->microsupport_admin_add_archive($id,$adminsID,$userID,addslashes($body),$date_time);
		}

    }
	$model->microsupport_admin_addnew_chat($userID,$adminsID,'Your Chats have been archived for later use, they have been deleted from the live chat.');

		  print "alldone=1";

}

if ($_REQUEST['requester'] == "donew_chat") {

	$userID = $_REQUEST['usersID'];
	$adminsID = $_REQUEST['adminsID'];
	$chat_body = $_REQUEST['chat_body'];
	$realadminid = $_REQUEST['realadminid'];

		if($userID == $realadminid)
    {
        $newrealadminid = $realadminid;
    }else{
        $newrealadminid = 0;
	}

		$getuserinfo = $model->_Getuserinfo($adminsID);
		$getadminuserinfo = $model->_Getuserinfo($userID);
		$getrealadmininfo = $model->_Getuserinfo($realadminid);

	if($realadminid > 0){
	$chat_body=str_replace("/useremail",$getuserinfo['email'],$chat_body);
	$chat_body=str_replace("/myemail",$getadminuserinfo['email'],$chat_body);

		if(stristr($chat_body, "/teach")){
			teach('Bot', $chat_body);
			//$model->microsupport_teach_ajaxbot($chat_body);
		}

		if(stristr($chat_body, "/unteach")){
			unteach('Bot', $chat_body);
			$model->microsupport_unteach_ajaxbot($chat_body);
		}

		if(stristr($chat_body, "/changebot")){
			$model->microsupport_changebotname_ajaxbot($chat_body);
		}

		if(stristr($chat_body, "/activatebot")){
			$model->microsupport_activatebot_ajaxbot($chat_body);
		}

		if(stristr($chat_body, "/archivechat")){
			$model->archivechat($userID,$adminsID,$newrealadminid);
		}
	}

	// /teach "Bot" "microsupport" => "microsupport is a support live chat system for xenforo"
if(stristr($chat_body, "/teach") OR stristr($chat_body, "/changebot") OR stristr($chat_body, "/activatebot") OR stristr($chat_body, "/unteach") OR stristr($chat_body, "/archivechat")){
		}else{
	$chat_body = formaturl($chat_body);

$botinfo['active'] = 0;
$botinfo = $model->getbotinfo();
if($botinfo['active'] == 1){
	include "mcsupport/bot/src/respond.php";
	if($_REQUEST['realadminid'] > 0){
		if(stristr($chat_body, "/bottest")){
	$chat_body=str_replace("/bottest",'',$chat_body);
	$pieces = explode(",", $chat_body);

	$template=str_replace(",","",$pieces[0]);
	$botresponse=replybotname($template,$userID,'Bot');
	if($botresponse->response == ''){
		$botresponseresponse = 'Sorry i have no responce for that question!';
	}else{
		$botresponseresponse = $botresponse->response;
	}
	$latest_id = $model->microsupport_ajaxbot_addnew_chat($adminsID,$userID,parseSmileys($botresponseresponse),1,$newrealadminid);
		}
	}else{
	$botresponse=replybotname($chat_body,$userID,'Bot');
	if($botresponse->response == ''){
		$botresponseresponse = 'Sorry i have no responce for that question!';
	}else{
		$botresponseresponse = $botresponse->response;
	}
	$latest_id = $model->microsupport_ajaxbot_addnew_chat($adminsID,$userID,parseSmileys($botresponseresponse),1,$newrealadminid);
	}
}
	$latest_id = $model->microsupport_user_addnew_chat($userID,$adminsID,parseSmileys($chat_body),$newrealadminid);
		}

     $body = "";
     $sql = $model->microsupport_admin_get_chat($userID,$adminsID);
	 
	 foreach ($sql AS $row)
		{
		$userinfo = $model->_Getuserinfo($row['usersid']);
              $id = $row["id"];
              $user_name = $userinfo["username"];
              $chat_body = $row["chat"];
              $date_time = $row["datetime"];
	     //$chat_body = stripslashes($chat_body);
         //$chat_body = eregi_replace("&#39;", "'", $chat_body);
	if($userID == $row['usersid']){
		$color = '#006699';
	}else{
		$color = '#FF0000';
	}
	     $body .= '<b><font color="'.$color.'">' . $user_name . ': </font></b>
	     <font color="#999999">' . $date_time . '</font>  
	     <font color="#000000"> '.$chat_body.'</font>
	     <br />';

     }

	//echo $xml_output;

		 // print "stored_id=$latest_id&statusline=poopoo&returnBody=$body";

}

		function teach($userName, $inStr)
		{
			$userId = 1;
			$bot['botid'] = 1;
			$bot    = $userName;

			if($bot['botid'] != null)
			{ 
				$pattern = '';
				$template = '';
				$arr = preg_split('/"/', $inStr);

				if(trim($arr[4]) == '=>' && count($arr) == 7)
				{
					$pattern  = strtoupper($arr[3]);
					$template = $arr[5];
				}

				if(strlen(trim($pattern)) != 0 && strlen(trim($template)) != 0)
				{
					include_once('mcsupport/bot/src/util.php');
					//$arr = normalsentences( $pattern );
					if(count($arr) > 0) $pattern = strtoupper($arr[3]);

					//remove if exists
					//unteach($userName, '"'.$pattern.'"', true);

					include_once('mcsupport/bot/src/admin/botloaderfuncs.php');
					$aimlstring = "<category><pattern>".$pattern."</pattern><template>".$template."</template></category>";
					$is_single = true;

					loadaimlstring($aimlstring, 1);

					return true;
				}
			}

			return false;
		}

		function unteach($userName, $inStr, $is_internal=false)
		{
			global $model;
			// /unteach "botname" "phrase" => "response"
			$arr = preg_split('/"/', $inStr);

			$inStr = $arr[3];
			if(count($arr) > 5) return false;

			$userId = 1;
			$bot['botid'] = 1;
			$bot    = 'Bot';

			if($bot['botid'] != null)
			{
				$botId = $bot['botid'];
				$stmt = $model->Statement($inStr);

				if(!$is_internal)
				{
					include_once('mcsupport/bot/src/util.php');
					//$arr = normalsentences( $inStr );
					if(count($arr) > 0) $inStr = strtoupper($arr[3]);
				}

				$stmt = $model->Statementdelete($stmt);

					return true;
			}

			return false; 
		}

		function parseSmileys($text){ 
    //List of words to replace 
    $smileys = array(':)',';)',':(',':mad:',':confused:',':cool:',':p',':D',':eek:',':oops:',':rolleyes:','o_O'); 
    $replacements = array('<img class="mceSmilieSprite mceSmilie1" title="Smile :)" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie2" title="Wink ;)" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie3" title="Frown :(" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie4" title="Mad    :mad:" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie5" title="Confused :confused:" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie6" title="Cool :cool:" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie7" title="Stick Out Tongue :p" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie8" title="Big Grin :D" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie9" title="Eek! :eek:" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie10" title="Oops! :oops:" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie11" title="Roll Eyes :rolleyes:" alt="" src="styles/default/xenforo/clear.png"></img>',
	'<img class="mceSmilieSprite mceSmilie12" title="Er... what? o_O" alt="" src="styles/default/xenforo/clear.png"></img>'); 
     
    return str_ireplace($smileys,$replacements,$text); 
}

		function formaturl($text){
			// The Regular Expression filter
$reg_exUrl = "/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/";

// Check if there is a url in the text
if(preg_match($reg_exUrl, $text, $url)) {

       // make the urls hyper links
       return preg_replace($reg_exUrl, '<a href="'.$url[0].'">'.$url[0].'</a> ', $text);

} else {

       // if no urls in the text just return the text
       return $text;

}
		}

if ($_REQUEST['requester'] == "domapuser") {

		$ip_addr = $_SERVER['REMOTE_ADDR'];
	$ipaddress = $ip_addr;
	$latitude = $_REQUEST['latitude'];
	$longitude = $_REQUEST['longitude'];
		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		if($latitude == '' && $longitude == ''){
			$geoplugin = unserialize( file_get_contents('http://www.geoplugin.net/php.gp?ip='.$ip_addr) );

if ( is_numeric($geoplugin['geoplugin_latitude']) && is_numeric($geoplugin['geoplugin_longitude']) ) {

$latitude = $geoplugin['geoplugin_latitude'];
$longitude = $geoplugin['geoplugin_longitude'];
}
		}

	$model->microsupport_add_mapuser($userid,$ipaddress,$latitude,$longitude);

		  print "alldone=1";

}