<?php

class MicroSupport_AlertHandler_FileReports extends XenForo_AlertHandler_DiscussionMessage
{

	public function getContentByIds(array $contentIds, $model, $userId, array $viewingUser)
	{

		/* @var $conversationModel XenForo_Model_Conversation */
			$Model = $model->getModelFromCache('MicroSupport_Model_MicroSupport');

		$files = $Model->AlertreportuseauthorByID($contentIds);

		return $Model->unserializePermissionsInList($files, 'node_permission_cache');
	}

	protected function _prepareReply(array $item)
	{
		if ($item['extra_data'])
		{
			$item['extra'] = unserialize($item['extra_data']);
			$item['product'] = $item['extra']['product'];
		}
		unset($item['extra_data']);

		return $item;
	}
}