<?php

    class MicroSupport_ControllerPublic_index extends XenForo_ControllerPublic_Abstract
    {

		public static function getSessionActivityDetailsForList(array $activities)
		{
			return new XenForo_Phrase('microsupport_location_phrase');
		}

        public function checklicesne()
        {
			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$licenseinfo = $model->adminLicenseinfo(1);

		$errors = 'brandedfree';
		return $errors;

		}

        public function actionClosed()
        {
			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

        $welcomemessage = $model->getMessageByID(5);
		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('HtmlEmail'));
		$welcomemessage['messageHtml'] = new XenForo_BbCode_TextWrapper($welcomemessage['bodytext'], $bbCodeParserHtml);

		$viewParams = array(
			'welcomemessage' => $welcomemessage,
			'settings' => $settings,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_closed', $viewParams);
        }

        public function actionIndex()
        {
		$act = $this->_input->filterSingle('act', XenForo_Input::STRING);

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

		$by = $this->_input->filterSingle('direction', XenForo_Input::STRING);
		if(isset($by) and $by=="desc"){
			$by="asc";
		}else{
			$by="desc";
		}

        $welcomemessage = $model->getMessageByID(1);
		$bbCodeParserHtml = new XenForo_BbCode_Parser(XenForo_BbCode_Formatter_Base::create('HtmlEmail'));
		$welcomemessage['messageHtml'] = new XenForo_BbCode_TextWrapper($welcomemessage['bodytext'], $bbCodeParserHtml);

		$importants = $model->getImportants($settings);
		$latests = $model->getLatest($settings);
		$latestdownloads = $model->getLatestDownloads($settings);
		$latestnews = $model->getFrontLatestNews($settings);

       $averagetime = $model->getResponseTime();
			$adminsonline = $model->microsupport_supportusers_online();
			$botinfo = $model->getbotinfo();

		$viewParams = array(
			'order' => 'title',
			//'orderDirection' => $orderDirection,
			'by' => $by,
			'botinfo' => $botinfo,
			'welcomemessage' => $welcomemessage,
			'settings' => $settings,
			'importants' => $importants,
			'latests' => $latests,
			'latestnews' => $latestnews,
			'latestdownloads' => $latestdownloads,
			'averagetime' => $averagetime[0],
			'copyright' => $copyright,
			'adminsonline' => $adminsonline
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_home', $viewParams);
        }

        public function actionNewticket()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

	if(!($model->CanAddNewTicket()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];
			$isguest = 0;

		if(!$userid){
			$isguest = 1;
		}

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

        $extrafieldsbits = $model->getextrafieldsbit();
        $departments = $model->getdepartments();
        $products = $model->getProducts();
		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'isguest' => $isguest,
			'departments' => $departments,
			'products' => $products,
			'extrafieldsbits' => $extrafieldsbits,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_Newticket', 'microsupport_newticket', $viewParams);
        }

        public function actionAddticket()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}
        	$settings = $model->adminSettingsinfo(1);

        $this->_assertPostOnly();
		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		if(!$userid){
			$session = XenForo_Application::get('session');
			//print_r($session);
		$userid = preg_replace('#[^0-9]#', '', $session->get('ip'));
		}

			$isguest = 0;

		if(!$userid){
			$isguest = 1;
		}

        $input = $this->_input->filter(array(
            'did' => XenForo_Input::UINT,
            'pid' => XenForo_Input::UINT,
            'title' => XenForo_Input::STRING,
            'guestemail' => XenForo_Input::STRING,
            'noupload' => XenForo_Input::UINT,
        ));
		if(!$input['guestemail']){
			$input['guestemail'] = '';
		}
		$input['message'] = $this->getHelper('Editor')->getMessageText('message', $this->_input);
		$input['message'] = XenForo_Helper_String::autoLinkBbCode($input['message']);
    $input['status'] = 1;
    $input['needaction'] = 1;
    $input['created'] = time();
    $input['updated'] = time();
    $input['newticket'] = 1;
    $input['userid'] = $userid;
    $input['priority'] = $model->Getpriorityoption();
    $input['newreply'] = 0;
	$flyer_name = '';

	if($input['noupload'] == 1){
              $flyer_name = '';
	}else{
    if($_FILES['flyer']['name']) {
      $ext=$model->get_ext($_FILES['flyer']['name']);
      // Check for allowed Attachment Types
	  $typesallowed = explode(",", $settings['upload_types']);
	  if (!in_array($ext, $typesallowed)) {
          $flyer_name = '';
      } else {
          $flyername  = $_FILES['flyer']["name"];
          if ($flyername=='') {
              $flyer_name = '';
          } else {
              $flyer_name=time()+rand(0,100000).".".$ext;
              $folder="mcsupport/attachments/";
              if(!@move_uploaded_file($_FILES['flyer']['tmp_name'],$folder.$flyer_name)) {
			     $flyer_name = '';
		      }
          }
      }
    }
	}
    $input['flyer_name'] = $flyer_name;

	$last_id = $model->InsertNewTicket($input);

		$fields = $this->_input->filterSingle('fields', XenForo_Input::STRING, array('array' => true));
	// Add Extra Fields
	if (is_array($fields))
	{
        $fieldid = 0;
	    foreach($fields AS $key => $fieldvalue)
	    {
	        // Its Text or Options?
	        if (is_array($fields[$key]))
	        {
	            foreach($fields[$key] AS $index => $value)
	            {
	                $value = trim($value);
                    if (empty($value))
                    {
                        unset($fields[$key][$index]);
                    }
	            }
                // Save the Options
	            $fieldvalue = implode(", ", $fields[$key]);
	        }
            $fieldvalue = addslashes(strip_tags($fieldvalue));

	$model->InsertNewTicketFields($last_id,$key,$fieldvalue);
    	}
	}

        $ticket = $model->GetTicket($last_id);

	$departmentid = $ticket["departmentid"];
       if($departmentid)
       {
          $emails = $model->getRecordById("microsupport_departments",$departmentid);
          if(!empty($emails["emails"]))
          {
              $toemails = explode(",", $emails['emails']);
              foreach($toemails AS $toemail)
              {
	$userinfo = $model->getRecordByEmail('xf_user', $toemail, 'email');

			$mailParams = array(
				'user' => $userinfo,
				'subject' => $settings['microsupport_email_subject'],
				'message' => $input['message']
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
                $userinfo['email'], // $toEmail
                $userinfo['username'], // $toName
                array(
                    'Sender' => $visitor['email'] // $headers
                ),
                $visitor['email'],  // $fromEmail
                XenForo_Application::get('options')->boardTitle, // $fromName
                $visitor['email'] // $returnPath
            );

	$model->AlertDepartmentTecs($ticket['id'], $userinfo['user_id'], $input['userid'], $isguest);
              }
          } else {
			  if($settings['microsupport_email_tech'] == ''){
			  }else{
	$userinfo = $model->getRecordByEmail('xf_user', $settings['microsupport_email_tech'], 'email');
	$model->AlertDepartmentTecs($ticket['id'], $userinfo['user_id'], $input['userid'], $isguest);

			$mailParams = array(
				'user' => $userinfo,
				'subject' => $settings['microsupport_email_subject'],
				'message' => $input['message']
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
				$userinfo['email'], '', array(
					'Sender' => $visitor['email']
				),
				$visitor['email'], $visitor['username']
			);

			  }
          }
       }
		$output = array();
			$output[] = array(
                'id' => $last_id,
                );

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/'.$last_id.'/replyticket')
			);
        }

        public function actionDownloads()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();
			$adminsonline = $model->microsupport_supportusers_online();
	   
		$perpage = 10;
        $downloads = $model->getDownloadFiles($perpage,$page);
        $totaldownloads = $model->getCountDownloadFiles();
		if($totaldownloads <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'downloads' => $downloads,
			'totaldownloads' => $totaldownloads,
			'adminsonline' => $adminsonline,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_list_downloads', $viewParams);
        }

        public function actionMytickets()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();
			$adminsonline = $model->microsupport_supportusers_online();
	   
		$perpage = 10;
        $mytickets = $model->getMyTickets($perpage,$page);
        $totalmytickets = $model->getCountMyTickets();
		if($totalmytickets <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'mytickets' => $mytickets,
			'totalmytickets' => $totalmytickets,
			'adminsonline' => $adminsonline,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_my_tickets', $viewParams);
        }

        public function actionCloseticket()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getCloseMyTicket($userid,$id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/mytickets')
			);

		}

        public function actionTcloseticket()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getTCloseMyTicket($userid,$id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/tickets')
			);

		}

        public function actionDeleteticket()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getDeleteMyTicket($userid,$id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/mytickets')
			);

		}

        public function actionDeletefaq()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getDeletefaq($id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/faqs')
			);

		}

        public function actionDeletepre()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getDeletepre($id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/listpre')
			);

		}

        public function actionTdeleteticket()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getTDeleteMyTicket($userid,$id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/tickets')
			);

		}

        public function actionTopenticket()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getTOpenMyTicket($userid,$id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/tickets')
			);

		}

        public function actionOpenticket()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getOpenMyTicket($userid,$id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/mytickets')
			);

		}

        public function actionReplyticket()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		if(!$userid){
			$session = XenForo_Application::get('session');
			//print_r($session);
		$userid = preg_replace('#[^0-9]#', '', $session->get('ip'));
		}

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}
		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);
		$predefiniedid = $this->_input->filterSingle('predefiniedid', XenForo_Input::UINT);
		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

		$quote = $this->_input->filterSingle('quote', XenForo_Input::UINT);

        $getticket = $model->GetTicket($id);

		$ticket = $getticket;
    	$owner = $ticket['userid'];

		if(($owner != $userid) AND (!($model->GetSupportTechnician()))){
            return $this->responseNoPermission();
		}

	if(!($model->GetSupportTechnician()))
    {
    }else{
		$model->UpdateTicketStstus($ticket['id'], 'newticket=0');
	}
	if($ticket['userid'] == $userid){
		$model->UpdateTicketStstus($ticket['id'], 'newreply=0');
	}

    if($settings["microsupport_departments"]==1)
    {
       $department = $model->getRecordById("microsupport_departments",$ticket["departmentid"]);
	} else {
       $department = '';
	}
    if($settings["microsupport_products"]==1)
    {
       $product = $model->getRecordById("microsupport_products",$ticket["productid"]);
	} else {
       $product = '';
    }

	$poster = $model->getRecordById("xf_user",$ticket["userid"],'user_id');
    $status = $model->getRecordById("microsupport_ticket_status",$ticket["status"]);

            $isphoto = 0;
    if(!empty($ticket["attachment"]))
    {
        $attachmentexists = 1;
        $ext=$model->get_ext($ticket["attachment"]);
        if ($ext=='gif' OR $ext=='jpeg' OR $ext=='jpg' OR $ext=='png')
        {
            $isphoto = 1;
        }else{
            $isphoto = 0;
        }
    }
	$extras = $model->getAllextrafieldsbit($ticket['id']);

		$perpage = 10;
		if($page == '' || $page == 0){
			$page = 1;
		}
		$replies = $model->getAllTicketReplies($ticket['id'],$userid,$perpage,$page);
        $totalreplies = $model->getCountTicketReplies($ticket['id']);
		if($totalreplies <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}

    // Functions for Templates
    $catid = 0;
   	if(!($model->GetSupportAttach()))
    {
       $can_attach = 0;
	} else {
	   $can_attach = 1;
	}
   	if(!($model->GetSupportTechnician()))
    {
       $can_close = 0;
	} else {
	   $can_close = 1;
	}
	$precheck = $model->getRecordById('microsupport_pre_stats', $ticket['id'], 'ticketid');
	if($precheck)
    {
       $preexists = 1;
    } else {
       $preexists = 0;
    }
    // Predefinied Replies
    $prewhere = "WHERE title<>''";
    if($settings["microsupport_departments"]==1)
    {
       $departmentid = $ticket["departmentid"];
       $prewhere .= " AND departmentid=$departmentid";
    }
    if($settings["microsupport_products"]==1)
    {
       $productid = $ticket["productid"];
       $prewhere .= " AND productid=$productid";
    }
	$prelists = $model->getAllPrelist($prewhere);

    // Load (or clear) predefinied reply
    if($predefiniedid>0)
    {
       $predefinied_reply = '';
	$predefinied_sql = $model->getRecordById('microsupport_predefinied', $predefiniedid, 'id');
	// insert pre to editor
    } else {
       // Setup Editor
		if($quote > 0){
	$getquote = $model->getRecordById('microsupport_ticket_replies', $quote, 'id');
	$predefinied_sql['message'] = $getquote['bodytext'];
		}else{
	$predefinied_sql['message'] = '';
		}
    }
    // Check if already added to F.A.Q
	$faqcheck = $model->getRecordById('microsupport_faq_stats', $ticket['id'], 'ticketid');
    if($faqcheck)
    {
       $faqexists = 1;
    } else {
       $faqexists = 0;
    }

	$subinfo = $model->getRecordById('microsupport_subscribe', $ticket['id'], 'tid');
	   if(!$subinfo){
		   $show['subscribed'] = true;
	   }else{
		   $show['subscribed'] = false;
	   }
			$adminsonline = $model->microsupport_supportusers_online();
       $averagetime = $model->getResponseTime();
	   
	//print $prewhere;
		//	print_r($prelists);
		//	exit();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'getticket' => $getticket,
			'department' => $department,
			'product' => $product,
			'poster' => $poster,
			'status' => $status,
			'isphoto' => $isphoto,
			'extras' => $extras,
			'replies' => $replies,
			'can_attach' => $can_attach,
			'can_close' => $can_close,
			'preexists' => $preexists,
			'prelists' => $prelists,
			'faqexists' => $faqexists,
			'show' => $show,
			'predefinied_sql' => $predefinied_sql,
			'page' => $page,
			'perpage' => $perpage,
			'totalreplies' => $totalreplies,
			'adminsonline' => $adminsonline,
			'averagetime' => $averagetime[0],
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_Replyticket', 'microsupport_reply_ticket', $viewParams);
        }

        public function actionTicketsub()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('ticketid', XenForo_Input::UINT);
		$subtoticket = $this->_input->filterSingle('subtoticket', XenForo_Input::UINT);

        $getticket = $model->GetTicket($id);

	$subinfo = $model->getRecordById('microsupport_subscribe', $getticket['id'], 'tid');
	   if(!$subinfo){
		   if($subtoticket == 1){
		$model->doTicketsub($id);
		   }
	   }
	   
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/replyticket', $getticket)
			);

		}

        public function actionSavereply()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];
		$isguest = 0;
		if(!$userid){
			$session = XenForo_Application::get('session');
			//print_r($session);
		$userid = preg_replace('#[^0-9]#', '', $session->get('ip'));
		$isguest = 1;
		}
		$input['userid'] = $userid;
        $settings = $model->adminSettingsinfo(1);

		$input['id'] = $this->_input->filterSingle('id', XenForo_Input::UINT);
		$input['subtoticket'] = $this->_input->filterSingle('subtoticket', XenForo_Input::UINT);
    	$input['closeticket'] = $this->_input->filterSingle('closeticket', XenForo_Input::UINT);
    	$input['transfer'] = $this->_input->filterSingle('transfer', XenForo_Input::UINT);
    	$input['predefinied'] = $this->_input->filterSingle('predefinied', XenForo_Input::UINT);
    	$input['faqtitle'] = $this->_input->filterSingle('faqtitle', XenForo_Input::STRING);
    	$input['pretitle'] = $this->_input->filterSingle('pretitle', XenForo_Input::STRING);
    	$input['categoryid'] = $this->_input->filterSingle('categoryid', XenForo_Input::UINT, array('array' => true));
    	$input['created'] = time();
		$input['message'] = $this->getHelper('Editor')->getMessageText('message', $this->_input);
		$input['bodytext'] = XenForo_Helper_String::autoLinkBbCode($input['message']);
    	$input['noflyer'] = $this->_input->filterSingle('noflyer', XenForo_Input::UINT);

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

		if(empty($_FILES['flyer'])){
			$input['noflyer'] = 1;
		}
	$flyer_name = '';
	if($input['noflyer'] == 1){
	}else{
    if($_FILES['flyer']['name']) {
      $ext=$model->get_ext($_FILES['flyer']['name']);
      // Check for allowed Attachment Types
	  $typesallowed = explode(",", $settings['upload_types']);
	  if (!in_array($ext, $typesallowed)) {
          $flyer_name = '';
      } else {
          $flyername  = $_FILES['flyer']["name"];
          if ($flyername=='') {
              $flyer_name = '';
          } else {
              $flyer_name=time()+rand(0,100000).".".$ext;
              $folder="mcsupport/attachments/";
              if(!@move_uploaded_file($_FILES['flyer']['tmp_name'],$folder.$flyer_name)) {
			     $flyer_name = '';
		      }
          }
      }
    }
	}
    $input['flyer_name'] = $flyer_name;

    $replyid = $model->SaveTicketReply($input);

        $ticket = $model->GetTicket($input['id']);
    // Add to Predefinied replies?
    if($input['predefinied']==1)
    {
       $predefinied['department'] = $ticket["departmentid"];
       $predefinied['product'] = $ticket["productid"];
	$predefinied['message'] = $input['bodytext'];
	$predefinied['pretitle'] = $input['pretitle'];
    $predefiniedid = $model->SavePredefinied($predefinied);
    $prestatsid = $model->UpdatePredefiniedStats($ticket['id']);

	}
    // Add to F.A.Q?
    if($input['transfer']==1)
    {
       $transfer['created'] = time();
       $transfer['important'] = 1;
       $transfer['answer'] = $input['bodytext'];
       $categories = $input['categoryid'];
	   $keys = array_keys($categories);
       foreach($keys as $idx) {
         $transfer['categoryid'] = $categories[$idx];
         $transfer['faqtitle'] = $input['faqtitle'];
		 
    	 $faqid = $model->SaveFAQS($transfer);
    $faqstatsid = $model->UpdateFAQStats($ticket['id']);
       }
	}
    // Who is the owner?
    $owner = $ticket['userid'];
    // Check if active user is the owner or if he has moderator permissions
		$isownder = 0;
		$istect = 0;
    if($owner == $input['userid'])
    {
		$isownder = 1;
       $needaction = 1;
       $emailclient = 0;
    } else {
		$istect = 1;
       $needaction = 0;
       $emailclient = 1;
    }

	$subinfo = $model->getRecordById('microsupport_subscribe', $ticket['id'], 'tid');
	if($subinfo['uid'] > 0){

	$userinfo = $model->getRecordById('xf_user', $subinfo['uid'], 'user_id');
		$linktoticket = XenForo_Link::buildPublicLink('support/replyticket', $ticket);
		  $boardUrl = XenForo_Application::get('options')->boardUrl;
		  $linktoticket = $boardUrl.'/'.$linktoticket;

       $message  = "";
       $message .= $settings["microsupport_email_salutation"]." ".$userinfo['username'].",";
       $message .= "
	   ";
       $message .= $settings['microsupport_subemail_body2'];
       $message .= "
	   ";
       $message .= "
	   ".$input['message']."
	   ";
       $message .= "
	   ";
       $message .= $linktoticket;
       $message .= "
	   ";
       $message .= "
	   ".$settings["microsupport_email_footer"]."
	   ";

			$mailParams = array(
				'user' => $userinfo,
				'subject' => '<TID'.$input['id'].'> '.$settings['microsupport_subemail_subject'],
				'message' => $message
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
                $userinfo['email'], // $toEmail
                $userinfo['username'], // $toName
                array(
                    'Sender' => $settings["microsupport_email_tech"] // $headers
                ),
                XenForo_Application::get('options')->microsupport_user,  // $fromEmail
                XenForo_Application::get('options')->boardTitle, // $fromName
                XenForo_Application::get('options')->microsupport_user // $returnPath
            );

			$model->SubscribeAlert($ticket['id']);
	}
    if($emailclient == 1)
    {
	$userinfo = $model->getRecordById('xf_user', $ticket['userid'], 'user_id');
		$linktoticket = XenForo_Link::buildPublicLink('support/replyticket', $ticket);
		  $boardUrl = XenForo_Application::get('options')->boardUrl;
		  $linktoticket = $boardUrl.'/'.$linktoticket;

       $message  = "";
       $message .= $settings["microsupport_email_salutation"]." ".$userinfo['username'].",";
       $message .= "
	   ";
       $message .= $settings['microsupport_email_body2'];
       $message .= "
	   ";
       $message .= "
	   ".$input['message']."
	   ";
       $message .= "
	   ";
       $message .= "
	   ".$linktoticket."
	   ";
       $message .= "
	   ".$settings["microsupport_email_footer"]."
	   ";

			$mailParams = array(
				'user' => $userinfo,
				'subject' => '<TID'.$input['id'].'> '.$settings['microsupport_email_subject'],
				'message' => $message
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
                $userinfo['email'], // $toEmail
                $userinfo['username'], // $toName
                array(
                    'Sender' => $settings["microsupport_email_tech"] // $headers
                ),
                XenForo_Application::get('options')->microsupport_user,  // $fromEmail
                XenForo_Application::get('options')->boardTitle, // $fromName
                XenForo_Application::get('options')->microsupport_user // $returnPath
            );

	$model->AlertUserTicketHolder($ticket['id'], $input['userid']);
    } else {

	$userinfo = $model->getRecordByEmail('xf_user', $settings['microsupport_email_tech'], 'email');
		$linktoticket = XenForo_Link::buildPublicLink('support/replyticket', $ticket);
		  $boardUrl = XenForo_Application::get('options')->boardUrl;
		  $linktoticket = $boardUrl.'/'.$linktoticket;

       $message  = "A new reply has been posted. Please take action.";
       $message  .= "
	   ";
       $message .= "
	   ".$input['message']."
	   ";
       $message  .= "
	   ";
       $message .= "
	   ".$linktoticket."
	   ";

			$mailParams = array(
				'user' => $userinfo,
				'subject' => '<TID'.$input['id'].'> '.$settings['microsupport_email_subject'],
				'message' => $message
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
                $visitor['email'], // $toEmail
                $visitor['username'], // $toName
                array(
                    'Sender' => $settings["microsupport_email_tech"] // $headers
                ),
                XenForo_Application::get('options')->microsupport_user,  // $fromEmail
                XenForo_Application::get('options')->boardTitle, // $fromName
                XenForo_Application::get('options')->microsupport_user // $returnPath
            );

			$model->UpdateNewReply($ticket['id']);

       $departmentid = $ticket["departmentid"];
       if($departmentid)
       {
          $emails = $model->getRecordById("microsupport_departments",$departmentid);
          if(!empty($emails["emails"]))
          {
              $toemails = explode(",", $emails['emails']);
              foreach($toemails AS $toemail)
              {
	$userinfo = $model->getRecordByEmail('xf_user', $toemail, 'email');

			$mailParams = array(
				'user' => $userinfo,
				'subject' => '<TID'.$input['id'].'> '.$settings['microsupport_email_subject'],
				'message' => $message
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
                $userinfo['email'], // $toEmail
                $userinfo['username'], // $toName
                array(
                    'Sender' => $visitor['email'] // $headers
                ),
                $visitor['email'],  // $fromEmail
                XenForo_Application::get('options')->boardTitle, // $fromName
                XenForo_Application::get('options')->microsupport_user // $returnPath
            );

	$model->AlertDepartmentTecs($ticket['id'], $userinfo['user_id'], $input['userid'], $isguest);
              }
          } else {
			  if($settings['microsupport_email_tech'] == ''){
			  }else{
	$userinfo = $model->getRecordByEmail('xf_user', $settings['microsupport_email_tech'], 'email');
	$model->AlertDepartmentTecs($ticket['id'], $userinfo['user_id'], $input['userid'], $isguest);

			$mailParams = array(
				'user' => $userinfo,
				'subject' => '<TID'.$input['id'].'> '.$settings['microsupport_email_subject'],
				'message' => $message
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
				$userinfo['email'], '', array(
					'Sender' => $visitor['email']
				),
				$visitor['email'], $visitor['username']
			);

			  }
          }
       } else {
			  if($settings['microsupport_email_tech'] == ''){
			  }else{
	$userinfo = $model->getRecordByEmail('xf_user', $settings['microsupport_email_tech'], 'email');
	$model->AlertDepartmentTecs($ticket['id'], $userinfo['user_id'], $input['userid'], $isguest);

			$mailParams = array(
				'user' => $userinfo,
				'subject' => '<TID'.$input['id'].'> '.$settings['microsupport_email_subject'],
				'message' => $message
			);

			$mail = XenForo_Mail::create('contact', $mailParams, 0);
			$mail->send(
				$userinfo['email'], '', array(
					'Sender' => $visitor['email']
				),
				$visitor['email'], $visitor['username']
			);

			  }
       }

	}
    if($input['closeticket'] == 1)
    {
       $status = 3;
    } else {
       $status = 2;
    }
    $updated = time();
    // Save Updates
    $model->SaveAndUpdateReply($status,$needaction,$updated,$ticket['id']);
	  
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/replyticket', $ticket),
				new XenForo_Phrase('your_message_has_been_posted')
			);

		}

        public function actionViewdownload()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

	    $getdownload = $model->getDownloadByID($id);
		if($getdownload['isaloud'] == false){
            return $this->responseNoPermission();
		}
       $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'copyright' => $copyright,
			'getdownload' => $getdownload,
			'averagetime' => $averagetime[0],
			'userid' => $userid
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_view_filedownload', $viewParams);
        }


	public function actionDownloadfile()
	{
			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }
		$Id = $this->_input->filterSingle('id', XenForo_Input::UINT);
		$key = $this->_input->filterSingle('key', XenForo_Input::STRING);

	    $sendfile = $model->getDownloadByID($Id);
        $settings = $model->adminSettingsinfo(1);

		if(!$Id){
            return $this->responseNoPermission();
		}
    if(!$sendfile)
    {
            return $this->responseNoPermission();
    }
		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

    // File exists, let's make one more check if user can download it (subscription expiration)
	if($userid == 0){
            return $this->responseNoPermission();
	}
    // File exists, let's check file download key against submitted key
		if($key == $sendfile["downloadkey"]){
			}else{
            return $this->responseNoPermission();
		}
	    $model->UpdateDownloadCountByID($Id);
		 $fname = $sendfile["downloadfile"];

    $filePath = $settings["microsupport_upload_path"] . $fname;
    $mtype = '';
    // mime type is not set, get from server settings
    if (function_exists('mime_content_type'))
    {
       $mtype = mime_content_type($filePath);
    }
       else if (function_exists('finfo_file')) {
            $finfo = finfo_open(FILEINFO_MIME); // return mime type
            $mtype = finfo_file($finfo, $filePath);
            finfo_close($finfo);
    }
    if ($mtype == '')
    {
        $mtype = "application/force-download";
    }
    
		$cdisposition = 'attachment';
	$this->_routeMatch->setResponseType('raw');

    $viewParams = array(
        'dlfilename' => $fname,
        'filename'     => $filePath,
        'cdisposition'     => $cdisposition,
        'ctype'     => $mtype
    );

    return $this->responseView('MicroSupport_ViewPublic_downloaddata', '', $viewParams);

	}

        public function actionKnowledgebase()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$catid = $this->_input->filterSingle('id', XenForo_Input::UINT);
		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

		$perpage = 15;
	    $categories = $model->listMainCategories($settings,$perpage,$page);
	    $allmaincats = $model->getCountAllMainCats();

		if($allmaincats <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}
       $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'categories' => $categories,
			'allmaincats' => $allmaincats,
			'page' => $page,
			'perpage' => $perpage,
			'averagetime' => $averagetime[0],
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_view_kbcategories', $viewParams);
        }

        public function actionViewskb()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$catid = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $category = $model->getkbCategoryByID($catid);
	    $subcategories = $model->listSubCategories($catid);

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

		$perpage = 15;
	    $items = $model->listCategoryItems($catid,$perpage,$page);
	    $allitems = $model->getCountAllItemCats($catid);

       $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'category' => $category,
			'subcategories' => $subcategories,
			'items' => $items,
			'allitems' => $allitems,
			'page' => $page,
			'perpage' => $perpage,
			'averagetime' => $averagetime[0],
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_list_kbcategories', $viewParams);
        }

        public function actionViewquestion()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $faq = $model->getRecordById('microsupport_faq', $id, 'id');

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'faq' => $faq,
			'averagetime' => $averagetime[0],
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_ViewFAQ', 'microsupport_view_kbfaq', $viewParams);
        }

        public function actionTickets()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

       $averagetime = $model->getResponseTime();
	   
		$perpage = 10;
        $mytickets = $model->getTechTickets($perpage,$page);
        $totalmytickets = $model->getCountTechTickets();

		if($totalmytickets <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}
        $departments = $model->AdminlistallTDepartments();

        $products = $model->AdminlistallTproducts();

        $status = $model->AdminlistallTicketstatus();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'mytickets' => $mytickets,
			'totalmytickets' => $totalmytickets,
			'departments' => $departments,
			'products' => $products,
			'status' => $status,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_tech_tickets', $viewParams);
        }

        public function actionSearchresults()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);
		$departmentid = $this->_input->filterSingle('departmentid', XenForo_Input::UINT);
		$productid = $this->_input->filterSingle('productid', XenForo_Input::UINT);
		$statusid = $this->_input->filterSingle('statusid', XenForo_Input::UINT);
    // Build WHERE for Query
    $where = "id>0";
    if($departmentid != 0)
    {
       $where .= " AND departmentid=".$departmentid;
    }
    if($productid != 0)
    {
       $where .= " AND productid=".$productid;
    }
    if($statusid != 0)
    {
       $where .= " AND status=".$statusid;
    }

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();
	   
		$perpage = 10;
        $mytickets = $model->getSearchTechTickets($where,$perpage,$page);
        $totalmytickets = $model->getCountSearchTechTickets($where);
		if($totalmytickets <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}
        $departments = $model->AdminlistallTDepartments();

        $products = $model->AdminlistallTproducts();

        $status = $model->AdminlistallTicketstatus();

		$pageNavParams = array(
			'departmentid' => $departmentid,
			'productid' => $productid,
			'statusid' => $statusid
		);

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'mytickets' => $mytickets,
			'totalmytickets' => $totalmytickets,
			'departments' => $departments,
			'products' => $products,
			'status' => $status,
			'pageNavParams' => $pageNavParams,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_techsearch_tickets', $viewParams);
        }

        public function actionFaqs()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

       $averagetime = $model->getResponseTime();
	   
		$perpage = 10;
        $mytickets = $model->getTechFaqs($perpage,$page);
        $totalmytickets = $model->getCountTechFaqs();
		if($totalmytickets <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}
        $departments = $model->AdminlistallTDepartments();

        $products = $model->AdminlistallTproducts();

        $status = $model->AdminlistallTicketstatus();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'mytickets' => $mytickets,
			'totalmytickets' => $totalmytickets,
			'departments' => $departments,
			'products' => $products,
			'status' => $status,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_tech_faqs', $viewParams);
        }

        public function actionListpre()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();
	   
		$perpage = 10;
        $mytickets = $model->getTechListpre($perpage,$page);
        $totalmytickets = $model->getCountTechListpre();
		if($totalmytickets <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}
        $departments = $model->AdminlistallTDepartments();

        $products = $model->AdminlistallTproducts();

        $status = $model->AdminlistallTicketstatus();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'mytickets' => $mytickets,
			'totalmytickets' => $totalmytickets,
			'departments' => $departments,
			'products' => $products,
			'status' => $status,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_tech_pre', $viewParams);
        }

        public function actionAddeditfaq()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}
		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

        $settings = $model->adminSettingsinfo(1);

		if($id == '' || $id == 0){
			$faq['answer'] = '';
		}else{
        $faq = $model->getRecordById('microsupport_faq', $id, 'id');
		}
        $categories = $model->AdminlistallFAQCategories();

        $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'averagetime' => $averagetime,
			'categories' => $categories,
			'copyright' => $copyright,
			'faq' => $faq
		);

            return $this->responseView('MicroSupport_ViewPublic_FAQ', 'microsupport_tect_addedit_faq', $viewParams);
        }

        public function actionAddeditpre()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}
		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

        $settings = $model->adminSettingsinfo(1);

		if($id == '' || $id == 0){
			$predefinied['message'] = '';
		}else{
	$predefinied = $model->getRecordById('microsupport_predefinied', $id, 'id');
		}
        $departments = $model->getdepartments();
        $products = $model->getProducts();

        $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'averagetime' => $averagetime,
			'departments' => $departments,
			'products' => $products,
			'copyright' => $copyright,
			'predefinied' => $predefinied
		);

            return $this->responseView('MicroSupport_ViewPublic_PRE', 'microsupport_tect_addedit_pre', $viewParams);
        }

        public function actionSaveupdatepre()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$input['userid'] = $visitor['user_id'];
        $settings = $model->adminSettingsinfo(1);

		$input['id'] = $this->_input->filterSingle('id', XenForo_Input::UINT);
		$input['departmentid'] = $this->_input->filterSingle('did', XenForo_Input::UINT);
		$input['productid'] = $this->_input->filterSingle('pid', XenForo_Input::UINT);

    	$input['title'] = $this->_input->filterSingle('title', XenForo_Input::STRING);

    	$input['categoryid'] = $this->_input->filterSingle('categoryid', XenForo_Input::UINT);
    
		$input['message'] = $this->getHelper('Editor')->getMessageText('message', $this->_input);
		$input['bodytext'] = XenForo_Helper_String::autoLinkBbCode($input['message']);

       $predefinied['department'] = $input["departmentid"];
       $predefinied['product'] = $input["productid"];
	   $predefinied['message'] = $input['bodytext'];
	   $predefinied['pretitle'] = $input['title'];
		 
		 if($input['id'] > 0){
         $predefinied['id'] = $input['id'];
       $predefiniedid = $model->UpdatePredefinied($predefinied);
		 }else{
       $predefiniedid = $model->SavePredefinied($predefinied);
		 }
	  
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/listpre')
			);

		}

        public function actionSaveupdatefaq()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$input['userid'] = $visitor['user_id'];
        $settings = $model->adminSettingsinfo(1);

		$input['id'] = $this->_input->filterSingle('id', XenForo_Input::UINT);

    	$input['faqtitle'] = $this->_input->filterSingle('question', XenForo_Input::STRING);

    	$input['categoryid'] = $this->_input->filterSingle('categoryid', XenForo_Input::UINT);
    
		$input['message'] = $this->getHelper('Editor')->getMessageText('message', $this->_input);
		$input['bodytext'] = XenForo_Helper_String::autoLinkBbCode($input['message']);

    // Add to F.A.Q?
       $transfer['created'] = time();
       $transfer['important'] = $this->_input->filterSingle('important', XenForo_Input::UINT);;
       $transfer['answer'] = $input['bodytext'];
	  
         $transfer['categoryid'] = $input['categoryid'];
         $transfer['faqtitle'] = $input['faqtitle'];
		 
		 if($input['id'] > 0){
         $transfer['id'] = $input['id'];
    	 $faqid = $model->UpdateFAQS($transfer);
		 }else{
    	 $faqid = $model->SaveFAQS($transfer);
		 }
	  
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/faqs')
			);

		}

        public function actionLivesupport()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		if($userid == 0){
			$ipaddress=$model->microsupport_getguest_ipaddress();
		if($ipaddress == 'none'){
            return $this->responseNoPermission();
		}else{
			$userid = trim($ipaddress);
		}
		}

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}
       $averagetime = $model->getResponseTime();
			$adminsonline = $model->microsupport_supportadvisers_online();

			$checkadminson = $model->microsupport_supportadvisers_onlineadmin($userid);
			$botinfo = $model->getbotinfo();

		$viewParams = array(
			'settings' => $settings,
			'botinfo' => $botinfo,
			'copyright' => $copyright,
			'averagetime' => $averagetime[0],
			'userid' => $userid,
			'adminsonline' => $adminsonline,
			'checkadminson' => $checkadminson
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_livesupport', $viewParams);
        }

        public function actionLivesupportoffline()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}
       $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'copyright' => $copyright,
			'averagetime' => $averagetime[0],
			'userid' => $userid
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_livesupport_onoffline', $viewParams);
        }

        public function actionAdvisorlogin()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

		$supportusertimeout = time()+120;

	if(!($model->GetSupportTechnician()))
    {
    }else{
	$model->microsupport_adminlogin_online($userid,$supportusertimeout);
	}

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/livesupport')
			);
        }

        public function actionAdvisorlogout()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

		$supportusertimeout = time()+120;

	if(!($model->GetSupportTechnician()))
    {
    }else{
	$model->microsupport_adminlogout_online($userid,$supportusertimeout);
	}

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/livesupport')
			);
        }

        public function actionlivechat()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$adminID = $this->_input->filterSingle('adminid', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];
		$username = $visitor['username'];

		if($userid == 0){
			$ipaddress=$model->microsupport_getguest_ipaddress();
		if($ipaddress == 'none'){
            return $this->responseNoPermission();
		}else{
			$userid = trim($ipaddress);
		$username = 'Guest';
		}
		}

		$usergroupID = $visitor["user_group_id"];
		$email = $visitor["email"];
		$timeout = time()+3600;

        $timout_sql = $model->microsupport_users_online($userid);

	   $status = 1;
		$model->microsupport_update_adminstatus($adminID, $status);
	   	   
   if($timout_sql['userid'] == ""){
		$model->microsupport_insert_users_online($userid,$username,$usergroupID,$email,$timeout);
		$model->microsupport_dochat_online($adminID,$userid,$timeout);
	   	   
		}

        $settings = $model->adminSettingsinfo(1);

        $dlcheck_sql = $model->ajaxchat_checkfordownload();

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);
		}

		$adminId = $this->_input->filterSingle('adminid', XenForo_Input::UINT);

		if(!($model->GetSupportTechnician()))
    {
        $realadminid = 0;
    }else{
        $realadminid = $userid;
	}

       $averagetime = $model->getResponseTime();
	   
	   $userchats = $model->microsupport_ajax_get_chat($userid,$adminId,$realadminid);

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'copyright' => $copyright,
			'averagetime' => $averagetime[0],
			'dlcheck_sql' => $dlcheck_sql,
			'userid' => $userid,
			'username' => $username,
			'adminId' => $adminId,
			'realadminid' => $realadminid,
			'userchats' => $userchats
		);
		if($userid == 0){
            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_livesupport_ajaxchat_error', $viewParams);
		}else{
            return $this->responseView('MicroSupport_ViewPublic_Ajaxlivechat', 'microsupport_livesupport_ajaxchat', $viewParams);
		}
        }

        public function actionAdvisorupload()
        {

		$adminId = $this->_input->filterSingle('adminId', XenForo_Input::UINT);
		$userid = $this->_input->filterSingle('userid', XenForo_Input::UINT);

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$viewParams = array(
			'adminId' => $adminId,
			'userid' => $userid
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_livesupport_uploadfile', $viewParams);
        }

        public function actionDouploadfile()
        {

        $this->_assertPostOnly();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

        $input = $this->_input->filter(array(
            'adminId' => XenForo_Input::UINT,
            'userid' => XenForo_Input::UINT,
        ));

		$adminId = $input['adminId'];
		$userid = $input['userid'];

		$uploadfilesize = ini_get("upload_max_filesize");
		$upload_max_filesize = str_replace("M","",$uploadfilesize);
		$upload_max_filesize = str_replace("m","",$upload_max_filesize);
		$limit_size = $upload_max_filesize * 1048576;
		$file_size=$_FILES['file']['size'];

	if(!empty($_FILES["file"]["name"]))
    {
		$filea = $_FILES["file"];
		$file = $model->uploadFile($filea);
		$file = $file;
    }

	$fileinfo = $model->uploadFileInsertSQL($file,$adminId,$userid);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/livechat?adminid='.$userid)
			);

        }

        public function actionLivelogout()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$adminsID = $this->_input->filterSingle('adminsID', XenForo_Input::UINT);
		$usersID = $this->_input->filterSingle('usersID', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];
		$username = $visitor['username'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);
		}
		if($userid == $usersID){
			$chat_body = $username.' has logged out!';
	$model->microsupport_user_addnew_chat($usersID,$adminsID,$chat_body,1);
	$model->microsupport_update_adminstatus($userid, 0);
	$model->microsupport_dochatlogout_online($adminsID,$userid);
		}else{
			$chat_body = $username.' has logged out!';
	$model->microsupport_user_addnew_chat($usersID,$adminsID,$chat_body,0);
		}
	$model->microsupport_dochatlogout_online($userid,$adminsID);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/livesupport')
			);
        }


	public function actionDownloadattachment()
	{
			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }
		$Id = $this->_input->filterSingle('id', XenForo_Input::UINT);

	    $sendfile = $model->getAttachmentByID($Id);
        $settings = $model->adminSettingsinfo(1);

		if(!$Id){
            return $this->responseNoPermission();
		}
    if(!$sendfile)
    {
            return $this->responseNoPermission();
    }
		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

    // File exists, let's make one more check if user can download it (subscription expiration)
	if($userid == 0){
            return $this->responseNoPermission();
	}

		 $fname = $sendfile["attachment"];
		 $fp = dirname(__FILE__);
		 $replacea = str_replace("library/", "", $fp);
		 $replaceb = str_replace("MicroSupport/", "", $replacea);
		 $replacec = str_replace("ControllerPublic", "", $replaceb);

    $filePath = $replacec.'mcsupport/attachments/' . $fname;

    $mtype = '';
    // mime type is not set, get from server settings
    if (function_exists('mime_content_type'))
    {
       $mtype = mime_content_type($filePath);
    }
       else if (function_exists('finfo_file')) {
            $finfo = finfo_open(FILEINFO_MIME); // return mime type
            $mtype = finfo_file($finfo, $filePath);
            finfo_close($finfo);
    }
    if ($mtype == '')
    {
        $mtype = "application/force-download";
    }
    
		$cdisposition = 'attachment';
	$this->_routeMatch->setResponseType('raw');

    $viewParams = array(
        'dlfilename' => $fname,
        'filename'     => $filePath,
        'cdisposition'     => $cdisposition,
        'ctype'     => $mtype
    );

    return $this->responseView('MicroSupport_ViewPublic_downloaddata', '', $viewParams);

	}

	public function actionDownloadticketattachment()
	{
			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }
		$Id = $this->_input->filterSingle('id', XenForo_Input::UINT);

	    $sendfile = $model->GetTicket($Id);
        $settings = $model->adminSettingsinfo(1);

		if(!$Id){
            return $this->responseNoPermission();
		}
    if(!$sendfile)
    {
            return $this->responseNoPermission();
    }
		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

    // File exists, let's make one more check if user can download it (subscription expiration)
	if($userid == 0){
            return $this->responseNoPermission();
	}

		 $fname = $sendfile["attachment"];
		 $fp = dirname(__FILE__);
		 $replacea = str_replace("library/", "", $fp);
		 $replaceb = str_replace("MicroSupport/", "", $replacea);
		 $replacec = str_replace("ControllerPublic", "", $replaceb);

    $filePath = $replacec.'mcsupport/attachments/' . $fname;

    $mtype = '';
    // mime type is not set, get from server settings
    if (function_exists('mime_content_type'))
    {
       $mtype = mime_content_type($filePath);
    }
       else if (function_exists('finfo_file')) {
            $finfo = finfo_open(FILEINFO_MIME); // return mime type
            $mtype = finfo_file($finfo, $filePath);
            finfo_close($finfo);
    }
    if ($mtype == '')
    {
        $mtype = "application/force-download";
    }
    
		$cdisposition = 'attachment';
	$this->_routeMatch->setResponseType('raw');

    $viewParams = array(
        'dlfilename' => $fname,
        'filename'     => $filePath,
        'cdisposition'     => $cdisposition,
        'ctype'     => $mtype
    );

    return $this->responseView('MicroSupport_ViewPublic_downloaddata', '', $viewParams);

	}

        public function actionPosttoticket()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$postId = $this->_input->filterSingle('post_id', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}
       $averagetime = $model->getResponseTime();
        $departments = $model->getdepartments();
        $products = $model->getProducts();

		$ftpHelper = $this->getHelper('ForumThreadPost');
		list($post, $thread, $forum) = $ftpHelper->assertPostValidAndViewable($postId);

		$viewParams = array(
			'post' => $post,
			'settings' => $settings,
			'departments' => $departments,
			'products' => $products,
			'copyright' => $copyright
		);

            return $this->responseView('XenForo_ViewPublic_Post_Edit', 'microsupport_do_posttoticket', $viewParams);
        }

	public function actionSaveinline()
	{
		$this->_assertPostOnly();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

		$postId = $this->_input->filterSingle('post_id', XenForo_Input::UINT);
		$did = $this->_input->filterSingle('did', XenForo_Input::UINT);
		$pid = $this->_input->filterSingle('pid', XenForo_Input::UINT);

		$ftpHelper = $this->getHelper('ForumThreadPost');
		list($post, $thread, $forum) = $ftpHelper->assertPostValidAndViewable($postId);
    $input['status'] = 1;
    $input['needaction'] = 1;
    $input['created'] = time();
    $input['updated'] = time();
    $input['newticket'] = 1;
    $input['userid'] = $post['user_id'];
    $input['priority'] = $model->Getpriorityoption();
    $input['newreply'] = 0;
    $input['flyer_name'] = '';
    $input['did'] = $did;
    $input['pid'] = $pid;
    $input['title'] = 'Post ID '.$postId;
    $input['guestemail'] = '';
    $input['message'] = XenForo_Helper_String::autoLinkBbCode(addslashes($post['message']));

	$model->InsertNewTicket($input);


		if ($this->_noRedirect())
		{
			$this->_request->setParam('thread_id', $thread['thread_id']);

			return $this->responseReroute('XenForo_ControllerPublic_Thread', 'show-posts');
		}
		else
		{
			return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('posts', $post)
			);
		}
	}

        public function actionPosttonews()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$postId = $this->_input->filterSingle('post_id', XenForo_Input::UINT);

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

        $settings = $model->adminSettingsinfo(1);

		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}
       $averagetime = $model->getResponseTime();
        $departments = $model->getdepartments();
        $products = $model->getProducts();

		$ftpHelper = $this->getHelper('ForumThreadPost');
		list($post, $thread, $forum) = $ftpHelper->assertPostValidAndViewable($postId);

		$viewParams = array(
			'post' => $post,
			'thread' => $thread,
			'settings' => $settings,
			'departments' => $departments,
			'products' => $products,
			'copyright' => $copyright
		);

            return $this->responseView('XenForo_ViewPublic_Post_Edit', 'microsupport_do_posttonews', $viewParams);
        }

	public function actionSavenewsinline()
	{
		$this->_assertPostOnly();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

		$postId = $this->_input->filterSingle('post_id', XenForo_Input::UINT);
		$title = $this->_input->filterSingle('title', XenForo_Input::STRING);

		$ftpHelper = $this->getHelper('ForumThreadPost');
		list($post, $thread, $forum) = $ftpHelper->assertPostValidAndViewable($postId);
    $input['status'] = 1;
    $input['created'] = time();
    $input['title'] = $title;
    $input['message'] = XenForo_Helper_String::autoLinkBbCode(addslashes($post['message']));

	if($title){
    $input['title'] = $thread['title'];
	}
	$model->InsertNewNews($input);


		if ($this->_noRedirect())
		{
			$this->_request->setParam('thread_id', $thread['thread_id']);

			return $this->responseReroute('XenForo_ControllerPublic_Thread', 'show-posts');
		}
		else
		{
			return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('posts', $post)
			);
		}
	}

        public function actionNews()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);

			if($settings['news'] == 0){
				return $this->responseError('Sorry the news system is not active at this time.');
			}
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();
			$adminsonline = $model->microsupport_supportusers_online();
	   
		$perpage = 10;
        $articals = $model->getLatestNews($perpage,$page);
        $totalarticals = $model->getCountLatestNews();
		if($totalarticals <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'articals' => $articals,
			'totalarticals' => $totalarticals,
			'adminsonline' => $adminsonline,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_NewsList', 'microsupport_list_news', $viewParams);
        }

        public function actionViewnews()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $faq = $model->getRecordById('microsupport_news', $id, 'id');

        $settings = $model->adminSettingsinfo(1);

			if($settings['news'] == 0){
				return $this->responseError('Sorry the news system is not active at this time.');
			}
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'faq' => $faq,
			'averagetime' => $averagetime[0],
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_ViewNews', 'microsupport_view_news', $viewParams);
        }

        public function actionChathelp()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$viewParams = array(
		);

            return $this->responseView('MicroSupport_ViewPublic_index', 'microsupport_livesupport_chathelp', $viewParams);
        }

        public function actionAddnews()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}
		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }

        $settings = $model->adminSettingsinfo(1);

		if($id == '' || $id == 0){
			$news['message'] = '';
		}else{
        $news = $model->getRecordById('microsupport_news', $id, 'id');
		}
        $categories = $model->AdminlistallFAQCategories();

        $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'averagetime' => $averagetime,
			'categories' => $categories,
			'copyright' => $copyright,
			'news' => $news
		);

            return $this->responseView('MicroSupport_ViewPublic_NEWS', 'microsupport_tect_addedit_news', $viewParams);
        }

	public function actionSaveupdatenews()
	{
		$this->_assertPostOnly();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }
		$postId = $this->_input->filterSingle('post_id', XenForo_Input::UINT);
		$input['title'] = $this->_input->filterSingle('title', XenForo_Input::STRING);
		$input['status'] = $this->_input->filterSingle('active', XenForo_Input::UINT);

    	$input['created'] = time();
		$input['message'] = $this->getHelper('Editor')->getMessageText('message', $this->_input);
		$input['message'] = XenForo_Helper_String::autoLinkBbCode($input['message']);

		if($postId > 0){
    	 $input['id'] = $postId;
    	 $model->UpdateNews($input);
		}else{
		 $model->InsertNewNews($input);
		}
		 
			return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/news')
			);
	}

        public function actionDeletenews()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }
	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);
        $faq = $model->getRecordById('microsupport_news', $id, 'id');

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}
		$newstitle = $faq['newstitle'];

       $averagetime = $model->getResponseTime();

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'settings' => $settings,
			'faq' => $faq,
			'newstitle' => $newstitle,
			'averagetime' => $averagetime[0],
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_ViewNews', 'microsupport_delete_news', $viewParams);
        }

        public function actionDodeletenews()
        {

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

	if(!($model->GetSupportTechnician()))
    {
            return $this->responseNoPermission();
    }
	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$id = $this->_input->filterSingle('id', XenForo_Input::UINT);

		$model->getDeleteNews($id);

		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/news')
			);

		}

        public function actionTechnews()
        {

			$errors = $this->checklicesne();

			$model = $this->getModelFromCache('MicroSupport_Model_MicroSupport');

			$techdepartments = $model->getdepartments();

			$techtotal = 0;
			foreach($techdepartments AS $row => $techdepartment)
		{
			$techusers = explode(",", $techdepartment['emails']);
			$techarrlength=count($techusers);
			$techtotal += $techarrlength;
			//print_r($techusers);
		}

			if($techtotal > 5){
				$techlimitreached = true;
			}else{
				$techlimitreached = true;
			}

			if(!$techlimitreached)
    {
				return $this->responseError('Sorry you have added to many tech users to your departments,<br />your limit is 5 tech users across all departments.<br /><br />If you would like more tech users you can use other release from <a href="http://www.reckonsteam.com/">here</a>');
    }

	if(!($model->CanAccessMicroSupport()))
    {
            return $this->responseNoPermission();
    }

			if($errors == 'licenseerror'){
				return $this->responseError('License is not valid.');
			}
			if($errors == 'licenseuser'){
				return $this->responseError('User Name is not valid.');
			}
			if($errors == 'licenseExpired'){
				return $this->responseError('License Has Expired.');
			}
			if($errors == 'licenseinstalledon'){
				return $this->responseError('License is Not Valid for This Domain.');
			}
			if($errors == 'licensefilemissing'){
				return $this->responseError('License File Not Found or Not Valid.');
			}
	if($errors == 'branded'){

			$thisscriptversion = $model->GetAddonInfo();

		$copyright = '<div class="shade footer_copyright">
           	     Powered by MicroSupport&reg;&nbsp;Version '.$thisscriptversion['version_string'].'<br />
                 Copyright &copy; 2012 xfgeek.com. All rights reserved.</div>';
 	}elseif($errors == 'brandedfree'){
		$copyright = '<div class="copyright"></div>';
	}

		$visitor = XenForo_Visitor::getInstance();
		$userid = $visitor['user_id'];

		$page = $this->_input->filterSingle('page', XenForo_Input::UINT);

        $settings = $model->adminSettingsinfo(1);
    
		if($settings['onoff'] == 0){
		return $this->responseRedirect(
				XenForo_ControllerResponse_Redirect::SUCCESS,
				XenForo_Link::buildPublicLink('support/closed')
			);

		}

       $averagetime = $model->getResponseTime();
			$adminsonline = $model->microsupport_supportusers_online();
	   
		$perpage = 10;
        $articals = $model->techgetLatestNews($perpage,$page);
        $totalarticals = $model->techgetCountLatestNews();
		if($totalarticals <= $perpage){
			$shownav = false;
		}else{
			$shownav = true;
		}

		$botinfo = $model->getbotinfo();

		$viewParams = array(
			'botinfo' => $botinfo,
			'shownav' => $shownav,
			'settings' => $settings,
			'averagetime' => $averagetime[0],
			'page' => $page,
			'perpage' => $perpage,
			'articals' => $articals,
			'totalarticals' => $totalarticals,
			'adminsonline' => $adminsonline,
			'copyright' => $copyright
		);

            return $this->responseView('MicroSupport_ViewPublic_NewsList', 'microsupport_techlist_news', $viewParams);
        }


    }
?>