<?php

class MicroSupport_Route_PrefixAdmin_MicroSupport implements XenForo_Route_Interface
{
    public function match($routePath, Zend_Controller_Request_Http $request, XenForo_Router $router)
    {

        $action = $router->resolveActionWithIntegerParam($routePath, $request, 'id');
        return $router->getRouteMatch('MicroSupport_ControllerAdmin_MicroSupport', $action, 'microsupportadmin');
    }

    public function buildLink($originalPrefix, $outputPrefix, $action, $extension, $data, array &$extraParams)
    {
        return XenForo_Link::buildBasicLinkWithIntegerParam($outputPrefix, $action, $extension, $data, 'id', 'title');
    }

}