<?php

class MicroSupport_WidgetRenderer_LatestNews extends WidgetFramework_WidgetRenderer {
	protected function _getConfiguration() {
		return array(
			'name' => '(MicroSupport) LatestNews',
		);
	}

	protected function _getOptionsTemplate() {
		return false;
	}

	protected function _getRenderTemplate(array $widget, $positionCode, array $params) {
		return 'microsupport_widget_latestnews_sidebar';
	}

	protected function _render(array $widget, $positionCode, array $params, XenForo_Template_Abstract $template) {

				$core = WidgetFramework_Core::getInstance();

				/* @var $threadModel XenForo_Model_Thread */
				$model = $core->getModelFromCache('MicroSupport_Model_MicroSupport');
        	$settings = $model->adminSettingsinfo(1);
        
		$latestnews = $model->getFrontLatestNews($settings);

		$template->setParam('latestnews', $latestnews);
		$template->setParam('settings', $settings);

		return $template->render();
	}

}